(* $Id: javaserial.isl,v 1.2 1997/05/19 23:47:14 jacobi Exp $ *)
(* Last edited by Chris Jacobi, May 19, 1997 1:49 pm PDT *)

INTERFACE javaserial;

TYPE SerializedJavaObject = 
  SEQUENCE OF BYTE;

TYPE JavaPickleBase = 
  RECORD
    bs: SerializedJavaObject,    (* The pickled object *)
    accessor: Accessor   (* Accessing classes  *)
  END;

TYPE String = 
  SEQUENCE OF CHARACTER;

TYPE JavaByteCodes = 
  SEQUENCE OF BYTE;

EXCEPTION javaserialException;

TYPE Accessor =
  OBJECT OPTIONAL 
    DOCUMENTATION "Accessing the bytecodes of the class"
    METHODS
      GetBytes(classname: String): JavaByteCodes RAISES javaserialException END
    END;
