/* CORBA_ObjectStub.java */
/* Chris Jacobi, August 20, 1997 1:45 pm PDT */

/*
 * Copyright (c) 1997 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: CORBA_ObjectStub.java,v 1.1 1997/08/20 20:47:22 jacobi Exp $ */
 

package xerox.ilu;

public class CORBA_ObjectStub 
        extends xerox.ilu.IluSurrogateObject 
        implements org.omg.CORBA.Object {
    
    static xerox.ilu.IluClassRep CORBA_Object_classRep;
    
    /** returns ilu class implemented by this stub class */
    static public xerox.ilu.IluClassRep iluClass() {
        return CORBA_Object_classRep;
    }//iluClass
    
    static private _CORBA_Object_skeletonClass _CORBA_Object_skeleton = 
        new _CORBA_Object_skeletonClass();
        
    static {
        CORBA_Object_classRep = xerox.ilu.IluClassRep.setupClass(
            "org.omg.CORBA.Object", //java reference interface
            "ilu.org.omg.CORBA.Object", //ilu object type
            "IDL:org.omg.CORBA.Object:1.0", //uuid
            0); //method count
        CORBA_Object_classRep.setOptional();
        CORBA_Object_classRep.setSurrClass(
            "xerox.ilu.CORBA_ObjectStub");
        CORBA_Object_classRep.setSurrFactory(
            new _CORBA_Object_Factory());
        CORBA_Object_classRep.setIfName("ilu"); 
        CORBA_ObjectHelper.id(); //makes sure helper class is loaded
        CORBA_Object_classRep.finishClass();
    }//static

    public static void registerTrueObject(
            java.lang.String _ih,
            org.omg.CORBA.Object _tob,
            xerox.ilu.IluServer _s) throws xerox.ilu.IluSystemException {
        xerox.ilu.Ilu.registerTrueObject(
            _ih, _tob, _s, CORBA_Object_classRep);
    } //registerTrueObject

    CORBA_ObjectStub() {
    }
    
    CORBA_ObjectStub(Object arg) {
    }
    
} //CORBA_ObjectStub


/* friendly */
class _CORBA_Object_Factory extends xerox.ilu.IluFactory {
    _CORBA_Object_Factory() { };
    public xerox.ilu.IluObject createSurrogateObject(Object _arg) {
        return new CORBA_ObjectStub();
    }
} // _CORBA_Object_Factory


/* friendly */
class _CORBA_Object_skeletonClass implements xerox.ilu.IluSkeleton {
    _CORBA_Object_skeletonClass() {
    }
    public void serveRequest(
            xerox.ilu.IluCall _call, xerox.ilu.IluMethodRep _m) 
            throws xerox.ilu.IluSystemException {
    } //serveRequest
} //_CORBA_Object_skeletonClass
