
/*  A Bison parser, made from idlparser.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse idlparse
#define yylex idllex
#define yyerror idlerror
#define yylval idllval
#define yychar idlchar
#define yydebug idldebug
#define yynerrs idlnerrs
#define	IDENT	258
#define	BOOL_FALSE	259
#define	BOOL_TRUE	260
#define	CHAR_L	261
#define	FLOAT_L	262
#define	INTEGER_L	263
#define	STRING_L	264
#define	FIXED_PT_L	265
#define	ONEWAY	266
#define	VOID_T	267
#define	IN	268
#define	OUT	269
#define	INOUT	270
#define	PRAGMA_ID	271
#define	PRAGMA_VERSION	272
#define	PRAGMA_PREFIX	273
#define	ANY_T	274
#define	ATTRIBUTE	275
#define	BOOLEAN_T	276
#define	CASE	277
#define	CHAR_T	278
#define	CONST	279
#define	CONTEXT	280
#define	DEFAULT	281
#define	DOUBLE_T	282
#define	ENUM	283
#define	EXCEPTION	284
#define	FIXED	285
#define	FLOAT_T	286
#define	INTERFACE	287
#define	LONG_T	288
#define	LSHIFT	289
#define	MODULE	290
#define	OBJECT_T	291
#define	NATIVE	292
#define	OCTET_T	293
#define	RAISES	294
#define	READONLY	295
#define	RSHIFT	296
#define	SCOPE	297
#define	SEQUENCE	298
#define	SHORT_T	299
#define	STRING_T	300
#define	STRUCT	301
#define	SWITCH	302
#define	TYPEDEF	303
#define	UNION	304
#define	UNSIGNED_T	305
#define	WCHAR_T	306
#define	WSTRING_T	307

#line 67 "idlparser.y"

#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <iluptype.h>
#include "iluidl.h"

#if (defined(WIN32) || defined(WIN16))
#include <malloc.h>	/* needed because of include of alloca */
#endif

/* tunable parameters. For 2.0a10 compatibility, all should be 0 */
#define LOCAL_TYPES_HAVE_REP_IDS  0
#define HAVE_SCOPING              0
#define HAVE_STRNDUP              0

/* Make the Bison parser produce better error messages */
#define YYERROR_VERBOSE
#include "idlparser-output.c"

  /* missing prototypes */
int yylex(void);
void FigureTypeUID(Type t);

#define ADD_PRIMITIVE_TYPES  \
  ADD_PRIMITIVE_TYPE (void)\
  ADD_PRIMITIVE_TYPE (short)\
  ADD_PRIMITIVE_TYPE (long)\
  ADD_PRIMITIVE_TYPE (long_long)\
  ADD_PRIMITIVE_TYPE (float)\
  ADD_PRIMITIVE_TYPE (double)\
  ADD_PRIMITIVE_TYPE (unsigned_short)\
  ADD_PRIMITIVE_TYPE (unsigned_long)\
  ADD_PRIMITIVE_TYPE (unsigned_long_long)\
  ADD_PRIMITIVE_TYPE (octet)\
  ADD_PRIMITIVE_TYPE (boolean)\
  ADD_PRIMITIVE_TYPE (char)\
  ADD_PRIMITIVE_TYPE (wchar)\
  ADD_PRIMITIVE_TYPE (object)\
  ADD_PRIMITIVE_TYPE (any)

#define ADD_PRIMITIVE_TYPE(x)  static IDLType the_##x##_t;
ADD_PRIMITIVE_TYPES
#undef ADD_PRIMITIVE_TYPE

static Type the_CORBA_Object;
static Interface the_ilu_module;
static Type the_ilu_CString;
static IDLType the_string_t;
static IDLType the_fixed_t;
static int next_serial=0;

list the_result=0;


#line 124 "idlparser.y"
typedef union{
  refany any; /*unspecified*/
  IDLDefinition definition;
  list definition_list;
  IDLName name;
  list name_list;
  IDLValue value;
  IDLType type;
  boolean flag;
  list string_list;
  list caselabel_list;
  ArgDirection inout;
  char opname;
  IDLCase caselabel;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		307
#define	YYFLAG		-32768
#define	YYNTBASE	74

#define YYTRANSLATE(x) ((unsigned)(x) <= 307 ? yytranslate[x] : 166)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,    66,    61,     2,    68,
    69,    64,    62,    57,    63,     2,    65,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    56,    53,    70,
    58,    71,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    72,     2,    73,    60,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    54,    59,    55,    67,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     8,    11,    14,    17,    19,    25,    27,
    30,    32,    34,    39,    42,    45,    50,    51,    53,    56,
    59,    62,    65,    68,    70,    73,    75,    78,    82,    84,
    88,    94,    96,    98,   100,   102,   104,   106,   108,   110,
   112,   114,   116,   118,   122,   124,   128,   130,   134,   136,
   140,   144,   146,   150,   154,   156,   160,   164,   168,   171,
   173,   175,   177,   179,   181,   183,   187,   189,   191,   193,
   195,   197,   199,   201,   203,   205,   207,   210,   213,   215,
   217,   219,   222,   225,   227,   229,   231,   233,   235,   237,
   239,   241,   243,   245,   247,   249,   251,   253,   255,   257,
   259,   261,   263,   265,   267,   271,   273,   275,   277,   279,
   281,   283,   285,   287,   289,   291,   293,   296,   298,   300,
   302,   304,   306,   310,   313,   316,   318,   320,   322,   324,
   326,   328,   334,   336,   339,   343,   353,   355,   357,   359,
   361,   363,   365,   367,   369,   372,   376,   378,   381,   385,
   388,   391,   397,   399,   403,   405,   412,   417,   422,   424,
   429,   431,   434,   437,   441,   446,   450,   451,   453,   459,
   460,   462,   469,   470,   472,   474,   476,   480,   483,   485,
   489,   493,   495,   497,   499,   500,   505,   506,   511,   513,
   517,   519,   521,   523,   525,   527,   534,   536,   538,   540
};

static const short yyrhs[] = {    77,
     0,   103,    53,     0,    87,    53,     0,   150,    53,     0,
    78,    53,     0,    76,    53,     0,   165,     0,    35,     3,
    54,    77,    55,     0,    75,     0,    77,    75,     0,    79,
     0,    80,     0,    81,    54,    82,    55,     0,    32,     3,
     0,    32,     3,     0,    32,     3,    56,    86,     0,     0,
    84,     0,   103,    53,     0,    87,    53,     0,   150,    53,
     0,   148,    53,     0,   152,    53,     0,    83,     0,    84,
    83,     0,     3,     0,    42,     3,     0,    85,    42,     3,
     0,    85,     0,    86,    57,    85,     0,    24,    88,     3,
    58,    89,     0,   115,     0,   124,     0,   125,     0,   126,
     0,   127,     0,   114,     0,   144,     0,   145,     0,   164,
     0,    85,     0,    90,     0,    91,     0,    90,    59,    91,
     0,    92,     0,    91,    60,    92,     0,    93,     0,    92,
    61,    93,     0,    94,     0,    93,    34,    94,     0,    93,
    41,    94,     0,    95,     0,    94,    62,    95,     0,    94,
    63,    95,     0,    96,     0,    95,    64,    96,     0,    95,
    65,    96,     0,    95,    66,    96,     0,    97,    98,     0,
    98,     0,    62,     0,    63,     0,    67,     0,    85,     0,
    99,     0,    68,    89,    69,     0,     8,     0,   102,     0,
     6,     0,    10,     0,     7,     0,   100,     0,     5,     0,
     4,     0,    89,     0,     9,     0,   102,     9,     0,    48,
   104,     0,   130,     0,   133,     0,   140,     0,    37,   112,
     0,   105,   110,     0,   106,     0,   109,     0,   107,     0,
   108,     0,    85,     0,   114,     0,   115,     0,   124,     0,
   125,     0,   126,     0,   127,     0,   129,     0,   128,     0,
   143,     0,   144,     0,   145,     0,   163,     0,   130,     0,
   133,     0,   140,     0,   111,     0,   110,    57,   111,     0,
   112,     0,   113,     0,     3,     0,   146,     0,    31,     0,
    27,     0,   116,     0,   120,     0,   118,     0,   119,     0,
   117,     0,    33,    33,     0,    33,     0,    44,     0,   122,
     0,   123,     0,   121,     0,    50,    33,    33,     0,    50,
    33,     0,    50,    44,     0,    23,     0,    51,     0,    21,
     0,    38,     0,    19,     0,    36,     0,    46,     3,    54,
   131,    55,     0,   132,     0,   131,   132,     0,   105,   110,
    53,     0,    49,     3,    47,    68,   134,    69,    54,   135,
    55,     0,   115,     0,   124,     0,   125,     0,   126,     0,
   127,     0,   140,     0,    85,     0,   136,     0,   135,   136,
     0,   137,   139,    53,     0,   138,     0,   137,   138,     0,
    22,    89,    56,     0,    26,    56,     0,   105,   111,     0,
    28,     3,    54,   141,    55,     0,   142,     0,   141,    57,
   142,     0,     3,     0,    43,    70,   106,    57,   101,    71,
     0,    43,    70,   106,    71,     0,    45,    70,   101,    71,
     0,    45,     0,    52,    70,   101,    71,     0,    52,     0,
     3,   147,     0,   146,   147,     0,    72,   101,    73,     0,
   149,    20,   162,   112,     0,   148,    57,   112,     0,     0,
    40,     0,    29,     3,    54,   151,    55,     0,     0,   131,
     0,   153,   154,     3,   155,   159,   160,     0,     0,    11,
     0,   162,     0,    12,     0,    68,   156,    69,     0,    68,
    69,     0,   157,     0,   156,    57,   157,     0,   158,   162,
   112,     0,    13,     0,    14,     0,    15,     0,     0,    39,
    68,    86,    69,     0,     0,    25,    68,   161,    69,     0,
   102,     0,   161,    57,   102,     0,   107,     0,   144,     0,
   145,     0,   163,     0,    85,     0,    30,    70,   101,    57,
   101,    71,     0,    30,     0,    17,     0,    16,     0,    18,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   187,   189,   190,   191,   192,   193,   194,   197,   203,   205,
   211,   212,   214,   219,   224,   231,   239,   240,   242,   243,
   244,   245,   246,   248,   253,   257,   258,   259,   262,   266,
   271,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,   293,   294,   295,   298,   299,   302,   303,   305,   306,
   308,   310,   311,   313,   315,   316,   318,   320,   322,   323,
   324,   325,   326,   327,   331,   332,   333,   334,   335,   336,
   337,   338,   340,   340,   341,   343,   344,   352,   353,   354,
   355,   356,   362,   368,   369,   375,   376,   377,   382,   383,
   384,   385,   386,   387,   388,   389,   391,   392,   393,   394,
   396,   397,   398,   400,   404,   407,   408,   410,   411,   413,
   414,   417,   418,   420,   421,   422,   423,   424,   425,   427,
   428,   429,   430,   431,   432,   434,   435,   436,   437,   438,
   439,   441,   450,   452,   454,   460,   472,   473,   474,   475,
   476,   477,   479,   483,   485,   488,   491,   493,   496,   498,
   501,   507,   514,   516,   518,   527,   532,   538,   540,   543,
   545,   548,   552,   555,   557,   564,   574,   575,   577,   582,
   583,   585,   596,   597,   599,   600,   602,   603,   606,   608,
   611,   618,   619,   620,   622,   623,   625,   626,   628,   630,
   633,   634,   635,   636,   637,   642,   648,   650,   651,   652
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","IDENT",
"BOOL_FALSE","BOOL_TRUE","CHAR_L","FLOAT_L","INTEGER_L","STRING_L","FIXED_PT_L",
"ONEWAY","VOID_T","IN","OUT","INOUT","PRAGMA_ID","PRAGMA_VERSION","PRAGMA_PREFIX",
"ANY_T","ATTRIBUTE","BOOLEAN_T","CASE","CHAR_T","CONST","CONTEXT","DEFAULT",
"DOUBLE_T","ENUM","EXCEPTION","FIXED","FLOAT_T","INTERFACE","LONG_T","LSHIFT",
"MODULE","OBJECT_T","NATIVE","OCTET_T","RAISES","READONLY","RSHIFT","SCOPE",
"SEQUENCE","SHORT_T","STRING_T","STRUCT","SWITCH","TYPEDEF","UNION","UNSIGNED_T",
"WCHAR_T","WSTRING_T","';'","'{'","'}'","':'","','","'='","'|'","'^'","'&'",
"'+'","'-'","'*'","'/'","'%'","'~'","'('","')'","'<'","'>'","'['","']'","specification",
"definition","module","definition_list","interface","interface_dcl","forward_dcl",
"interface_header","interface_body","export","export_list","scoped_name","scoped_name_list",
"const_dcl","const_type","const_expr","or_expr","xor_expr","and_expr","shift_expr",
"add_expr","mult_expr","unary_expr","unary_operator","primary_expr","literal",
"boolean_literal","positive_const_int","string_literal","type_dcl","type_declarator",
"type_spec","simple_type_spec","base_type_spec","template_type_spec","constr_type_spec",
"declarators","declarator","simple_declarator","complex_declarator","floating_pt_type",
"integer_type","signed_int","signed_long_long_int","signed_long_int","signed_short_int",
"unsigned_int","unsigned_long_long_int","unsigned_long_int","unsigned_short_int",
"char_type","wide_char_type","boolean_type","octet_type","any_type","object_type",
"struct_type","member_list","member","union_type","switch_type_spec","switch_body",
"case","case_label_list","case_label","element_spec","enum_type","enumerator_list",
"enumerator","sequence_type","string_type","wide_string_type","array_declarator",
"fixed_array_size","attr_dcl","opt_readonly","except_dcl","opt_member_list",
"op_dcl","opt_op_attr","op_type_spec","parameter_dcls","param_dcl_list","param_dcl",
"param_attribute","opt_raises_expr","opt_context_expr","string_literal_list",
"param_type_spec","fixed_pt_type","fixed_pt_const_type","pragma", NULL
};
#endif

static const short yyr1[] = {     0,
    74,    75,    75,    75,    75,    75,    75,    76,    77,    77,
    78,    78,    79,    80,    81,    81,    82,    82,    83,    83,
    83,    83,    83,    84,    84,    85,    85,    85,    86,    86,
    87,    88,    88,    88,    88,    88,    88,    88,    88,    88,
    88,    89,    90,    90,    91,    91,    92,    92,    93,    93,
    93,    94,    94,    94,    95,    95,    95,    95,    96,    96,
    97,    97,    97,    98,    98,    98,    99,    99,    99,    99,
    99,    99,   100,   100,   101,   102,   102,   103,   103,   103,
   103,   103,   104,   105,   105,   106,   106,   106,   107,   107,
   107,   107,   107,   107,   107,   107,   108,   108,   108,   108,
   109,   109,   109,   110,   110,   111,   111,   112,   113,   114,
   114,   115,   115,   116,   116,   116,   117,   118,   119,   120,
   120,   120,   121,   122,   123,   124,   125,   126,   127,   128,
   129,   130,   131,   131,   132,   133,   134,   134,   134,   134,
   134,   134,   134,   135,   135,   136,   137,   137,   138,   138,
   139,   140,   141,   141,   142,   143,   143,   144,   144,   145,
   145,   146,   146,   147,   148,   148,   149,   149,   150,   151,
   151,   152,   153,   153,   154,   154,   155,   155,   156,   156,
   157,   158,   158,   158,   159,   159,   160,   160,   161,   161,
   162,   162,   162,   162,   162,   163,   164,   165,   165,   165
};

static const short yyr2[] = {     0,
     1,     2,     2,     2,     2,     2,     1,     5,     1,     2,
     1,     1,     4,     2,     2,     4,     0,     1,     2,     2,
     2,     2,     2,     1,     2,     1,     2,     3,     1,     3,
     5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     3,     1,     3,     1,     3,     1,     3,
     3,     1,     3,     3,     1,     3,     3,     3,     2,     1,
     1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     2,     2,     1,     1,
     1,     2,     2,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     2,     1,     1,     1,
     1,     1,     3,     2,     2,     1,     1,     1,     1,     1,
     1,     5,     1,     2,     3,     9,     1,     1,     1,     1,
     1,     1,     1,     1,     2,     3,     1,     2,     3,     2,
     2,     5,     1,     3,     1,     6,     4,     4,     1,     4,
     1,     2,     2,     3,     4,     3,     0,     1,     5,     0,
     1,     6,     0,     1,     1,     1,     3,     2,     1,     3,
     3,     1,     1,     1,     0,     4,     0,     4,     1,     3,
     1,     1,     1,     1,     1,     6,     1,     1,     1,     1
};

static const short yydefact[] = {     0,
   199,   198,   200,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     9,     0,     1,     0,    11,    12,     0,     0,
     0,    79,    80,    81,     0,     7,    26,   128,   126,   111,
   197,   110,   118,   129,     0,   119,   159,     0,   127,   161,
    41,     0,    37,    32,   112,   116,   114,   115,   113,   122,
   120,   121,    33,    34,    35,    36,    38,    39,    40,     0,
     0,    14,     0,   108,    82,     0,   130,     0,   131,     0,
    88,    78,     0,    84,    86,    87,    85,    89,    90,    91,
    92,    93,    94,    96,    95,   101,   102,   103,    97,    98,
    99,   100,     0,     6,    10,     5,   173,     3,     2,     4,
   117,    27,     0,   124,   125,     0,     0,     0,     0,   170,
     0,     0,     0,     0,     0,   108,    83,   104,   106,   107,
   109,     0,   174,   168,     0,    24,   173,     0,     0,     0,
     0,     0,     0,     0,    74,    73,    69,    71,    67,    76,
    70,    61,    62,    63,     0,    64,    75,    42,    43,    45,
    47,    49,    52,    55,     0,    60,    65,    72,     0,    68,
   123,     0,    28,     0,   155,     0,   153,     0,   171,   133,
     0,    29,    16,     0,     0,     0,     0,     0,   162,     0,
   163,     0,    13,    25,    20,    19,    22,     0,     0,    21,
    23,   176,   195,   191,   192,   193,     0,   175,   194,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    59,   158,    77,   160,    31,   152,     0,     0,   134,   169,
     0,     8,   132,     0,     0,   157,     0,   105,   143,   137,
   138,   139,   140,   141,     0,   142,   166,     0,     0,    66,
    44,    46,    48,    50,    51,    53,    54,    56,    57,    58,
   154,   135,    30,     0,     0,   164,     0,   165,     0,   185,
   196,   156,     0,   182,   183,   184,   178,     0,   179,     0,
     0,   187,     0,     0,     0,   144,     0,   147,     0,   177,
     0,     0,     0,   172,     0,   150,   136,   145,     0,   148,
     0,   180,   181,     0,     0,   149,   151,   146,   186,   189,
     0,     0,   188,   190,     0,     0,     0
};

static const short yydefgoto[] = {   305,
    13,    14,    15,    16,    17,    18,    19,   125,   126,   127,
   146,   173,    20,    42,   147,   148,   149,   150,   151,   152,
   153,   154,   155,   156,   157,   158,   159,   160,    21,    72,
   168,    74,    75,    76,    77,   117,   118,   119,   120,    78,
    79,    45,    46,    47,    48,    49,    50,    51,    52,    80,
    81,    82,    83,    84,    85,    22,   169,   170,    23,   235,
   275,   276,   277,   278,   291,    24,   166,   167,    89,    90,
    91,   121,   179,   130,   131,    25,   171,   133,   134,   197,
   260,   268,   269,   270,   272,   284,   301,   198,    92,    59,
    26
};

static const short yypact[] = {   467,
-32768,-32768,-32768,   423,    53,    56,    61,    80,    94,   112,
   295,   124,-32768,    89,   467,    93,-32768,-32768,    79,    99,
   100,-32768,-32768,-32768,   102,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   110,-32768,   153,-32768,    87,    25,-32768,    88,
   118,   159,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   128,
   129,   -32,   130,-32768,-32768,   135,-32768,    96,-32768,   123,
   118,-32768,   169,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   148,-32768,-32768,-32768,   213,-32768,-32768,-32768,
-32768,-32768,    24,   164,-32768,    24,   196,   143,   199,   295,
    18,   467,   295,    24,   329,   131,   149,-32768,-32768,-32768,
   131,   141,-32768,-32768,   156,-32768,   452,   161,   163,    41,
   192,   165,   172,   363,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    24,   118,-32768,   171,   174,   175,
    55,    76,    54,-32768,    35,-32768,-32768,-32768,   167,   226,
-32768,   168,-32768,    24,-32768,    77,-32768,   169,   295,-32768,
   185,   118,   186,    33,   177,   187,   -34,    24,-32768,   169,
-32768,   126,-32768,-32768,-32768,-32768,-32768,    94,   397,-32768,
-32768,-32768,   118,-32768,-32768,-32768,   242,-32768,-32768,   178,
    24,    24,    24,    24,    24,    24,    24,    24,    24,    24,
-32768,-32768,-32768,-32768,-32768,-32768,   199,    42,-32768,-32768,
    18,-32768,-32768,    24,    24,-32768,   173,-32768,   118,-32768,
-32768,-32768,-32768,-32768,   179,-32768,-32768,    94,   181,-32768,
   174,   175,    55,    76,    76,    54,    54,-32768,-32768,-32768,
-32768,-32768,   118,   180,   183,-32768,   198,-32768,    39,   216,
-32768,-32768,    90,-32768,-32768,-32768,-32768,   -22,-32768,   397,
   188,   232,    24,   202,    49,-32768,   261,-32768,   108,-32768,
    94,    18,   195,-32768,   204,-32768,-32768,-32768,   169,-32768,
   212,-32768,-32768,    15,   266,-32768,-32768,-32768,-32768,   226,
    16,   266,-32768,   226,   270,   276,-32768
};

static const short yypgoto[] = {-32768,
   -11,-32768,   184,-32768,-32768,-32768,-32768,-32768,   152,-32768,
    -4,     3,   -72,-32768,  -128,-32768,    85,    91,    92,   -64,
   -56,   -84,-32768,   145,-32768,-32768,   -88,  -202,   -51,-32768,
    -5,   193,  -126,-32768,-32768,   122,  -161,    -7,-32768,   297,
     5,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,     6,
     9,    10,    12,-32768,-32768,     0,   189,   -95,     4,-32768,
-32768,    34,-32768,    38,-32768,    -8,-32768,   103,-32768,    -3,
     1,-32768,   200,-32768,-32768,   -49,-32768,-32768,-32768,-32768,
-32768,-32768,    40,-32768,-32768,-32768,-32768,  -169,  -122,-32768,
-32768
};


#define	YYLAST		516


static const short yytable[] = {    41,
    57,    65,    88,    95,    58,    73,    71,   194,    44,    53,
    86,   199,    54,    55,    87,    56,   200,   162,   228,   238,
    27,   -15,   225,   111,   128,   176,    27,   135,   136,   137,
   138,   139,   140,   141,   279,   215,   226,    27,   135,   136,
   137,   138,   139,   140,   141,   129,   280,   132,     1,     2,
     3,   264,   265,   266,   128,    60,     4,   104,    61,    35,
     5,     6,   194,    62,     7,    35,   199,     8,   105,     9,
   273,   221,   302,   219,   274,   129,    35,   132,    10,   219,
    11,    12,    63,   299,   303,   142,   143,   222,   204,   227,
   144,   145,   300,   187,   252,   205,    64,   188,   180,   304,
   281,    88,   145,   287,    88,    71,   172,   267,    71,    86,
    71,   273,    86,    87,    66,   274,    87,   208,   209,   210,
   264,   265,   266,   248,   249,   250,    93,   297,    27,   193,
   195,   216,    97,   217,   196,   254,   255,   206,   207,   244,
   245,    94,   101,   194,   285,    96,    28,   199,    29,   246,
   247,    98,    99,     5,   100,   102,   103,   106,    33,   107,
    88,   108,    95,    34,    71,   114,    88,    35,    86,    36,
    71,   116,    87,   236,    86,    38,    39,   229,    87,    27,
   237,   109,   110,   112,   193,   195,   230,   231,   113,   196,
   232,   233,   115,   234,   122,    67,   161,    28,   163,    29,
   164,   165,   178,    30,     5,   180,    68,    32,   182,    33,
   183,   189,    69,   185,    34,   186,   253,   190,    35,    70,
    36,    37,    10,   123,   191,    12,    38,    39,    40,   201,
   258,   223,  -167,   202,   213,   203,     4,   212,   214,   220,
     5,     6,   221,   224,   239,   256,   240,   257,   259,     9,
   261,   263,   124,   262,   271,   282,   283,   286,    10,   296,
    11,    12,   295,    27,   298,   193,   195,   -17,    88,   306,
   196,   289,    71,   293,   140,   307,    86,   172,   184,    67,
    87,    28,   273,    29,   294,   241,   274,    30,     5,   218,
    68,    32,   242,    33,   243,   174,    69,    27,    34,   211,
    43,   175,    35,    70,    36,    37,    10,   177,   288,    12,
    38,    39,    40,    67,   290,    28,     0,    29,   292,   251,
   181,    30,     5,     0,    68,    32,     0,    33,     0,     0,
    69,    27,    34,     0,     0,     0,    35,    70,    36,    37,
    10,     0,     0,    12,    38,    39,    40,    67,     0,    28,
     0,    29,     0,     0,     0,    30,     0,     0,    68,    32,
     0,    33,     0,     0,    69,    27,    34,     0,     0,     0,
    35,    70,    36,    37,   192,     0,     0,     0,    38,    39,
    40,    67,     0,    28,     0,    29,     0,     0,     0,    30,
     0,     0,    68,    32,     0,    33,     0,     0,    69,    27,
    34,     0,     0,     0,    35,     0,    36,    37,     0,     0,
     0,     0,    38,    39,    40,    67,     0,    28,     0,    29,
     0,     0,     0,    30,     0,    27,    68,    32,     0,    33,
     0,     0,    69,     0,    34,     0,     0,     0,    35,     0,
    36,    37,     0,    28,     0,    29,    38,    39,    40,    30,
     0,     0,    31,    32,     0,    33,     0,     0,     0,     0,
    34,     0,   123,     0,    35,     0,    36,    37,     0,     0,
     0,  -167,    38,    39,    40,     4,     0,     0,     0,     5,
     6,     0,     1,     2,     3,     0,     0,     0,     9,     0,
     4,   124,     0,     0,     5,     6,     0,    10,     7,    11,
    12,     8,     0,     9,     0,     0,   -18,     0,     0,     0,
     0,     0,    10,     0,    11,    12
};

static const short yycheck[] = {     4,
     4,     9,    11,    15,     4,    11,    11,   134,     4,     4,
    11,   134,     4,     4,    11,     4,   145,   106,   180,   189,
     3,    54,    57,    56,    97,   114,     3,     4,     5,     6,
     7,     8,     9,    10,    57,   164,    71,     3,     4,     5,
     6,     7,     8,     9,    10,    97,    69,    97,    16,    17,
    18,    13,    14,    15,   127,     3,    24,    33,     3,    42,
    28,    29,   189,     3,    32,    42,   189,    35,    44,    37,
    22,    57,    57,   169,    26,   127,    42,   127,    46,   175,
    48,    49,     3,    69,    69,    62,    63,    55,    34,   178,
    67,    68,   295,    53,    53,    41,     3,    57,    57,   302,
   270,   110,    68,    55,   113,   110,   111,    69,   113,   110,
   115,    22,   113,   110,     3,    26,   113,    64,    65,    66,
    13,    14,    15,   208,   209,   210,     3,   289,     3,   134,
   134,    55,    54,    57,   134,   224,   225,    62,    63,   204,
   205,    53,    33,   270,   273,    53,    21,   270,    23,   206,
   207,    53,    53,    28,    53,     3,    70,    70,    33,    42,
   169,     3,   174,    38,   169,    70,   175,    42,   169,    44,
   175,     3,   169,   182,   175,    50,    51,   182,   175,     3,
   188,    54,    54,    54,   189,   189,   182,   182,    54,   189,
   182,   182,    70,   182,    47,    19,    33,    21,     3,    23,
    58,     3,    72,    27,    28,    57,    30,    31,    68,    33,
    55,    20,    36,    53,    38,    53,   221,    53,    42,    43,
    44,    45,    46,    11,    53,    49,    50,    51,    52,    59,
   238,    55,    20,    60,     9,    61,    24,    71,    71,    55,
    28,    29,    57,    57,     3,    73,    69,    69,    68,    37,
    71,    54,    40,    71,    39,    68,    25,    56,    46,    56,
    48,    49,    68,     3,    53,   270,   270,    55,   277,     0,
   270,   277,   277,   281,     9,     0,   277,   282,   127,    19,
   277,    21,    22,    23,   282,   201,    26,    27,    28,   168,
    30,    31,   202,    33,   203,   112,    36,     3,    38,   155,
     4,   113,    42,    43,    44,    45,    46,   115,   275,    49,
    50,    51,    52,    19,   277,    21,    -1,    23,   279,   217,
   121,    27,    28,    -1,    30,    31,    -1,    33,    -1,    -1,
    36,     3,    38,    -1,    -1,    -1,    42,    43,    44,    45,
    46,    -1,    -1,    49,    50,    51,    52,    19,    -1,    21,
    -1,    23,    -1,    -1,    -1,    27,    -1,    -1,    30,    31,
    -1,    33,    -1,    -1,    36,     3,    38,    -1,    -1,    -1,
    42,    43,    44,    45,    12,    -1,    -1,    -1,    50,    51,
    52,    19,    -1,    21,    -1,    23,    -1,    -1,    -1,    27,
    -1,    -1,    30,    31,    -1,    33,    -1,    -1,    36,     3,
    38,    -1,    -1,    -1,    42,    -1,    44,    45,    -1,    -1,
    -1,    -1,    50,    51,    52,    19,    -1,    21,    -1,    23,
    -1,    -1,    -1,    27,    -1,     3,    30,    31,    -1,    33,
    -1,    -1,    36,    -1,    38,    -1,    -1,    -1,    42,    -1,
    44,    45,    -1,    21,    -1,    23,    50,    51,    52,    27,
    -1,    -1,    30,    31,    -1,    33,    -1,    -1,    -1,    -1,
    38,    -1,    11,    -1,    42,    -1,    44,    45,    -1,    -1,
    -1,    20,    50,    51,    52,    24,    -1,    -1,    -1,    28,
    29,    -1,    16,    17,    18,    -1,    -1,    -1,    37,    -1,
    24,    40,    -1,    -1,    28,    29,    -1,    46,    32,    48,
    49,    35,    -1,    37,    -1,    -1,    55,    -1,    -1,    -1,
    -1,    -1,    46,    -1,    48,    49
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "/usr/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 187 "idlparser.y"
{the_result=yyvsp[0].definition_list;;
    break;}
case 8:
#line 198 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=MODULEtag;
		yyval.definition->name=yyvsp[-3].name;
		yyval.definition->u.module.definitions=yyvsp[-1].definition_list;
	;
    break;}
case 9:
#line 204 "idlparser.y"
{       yyval.definition_list=iluparser_new_list();deflist_insert(yyval.definition_list,yyvsp[0].definition);;
    break;}
case 10:
#line 206 "idlparser.y"
{	deflist_insert(yyvsp[-1].definition_list,yyvsp[0].definition);
		yyval.definition_list=yyvsp[-1].definition_list;
	;
    break;}
case 13:
#line 215 "idlparser.y"
{	yyvsp[-3].definition->u.interface.definitions=yyvsp[-1].definition_list;
		yyval.definition=yyvsp[-3].definition;
	;
    break;}
case 14:
#line 220 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=INTERFACEFWDtag;
		yyval.definition->name=yyvsp[0].name;
	;
    break;}
case 15:
#line 225 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=INTERFACEtag;
		yyval.definition->name=yyvsp[0].name;
		yyval.definition->u.interface.bases=NULL;
		yyval.definition->u.interface.definitions=NULL;
		yyval.definition->u.interface.resolution_state=0;
	;
    break;}
case 16:
#line 232 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=INTERFACEtag;
		yyval.definition->name=yyvsp[-2].name;yyval.definition->u.interface.bases=yyvsp[0].name_list;
		yyval.definition->u.interface.definitions=NULL;
		yyval.definition->u.interface.resolution_state=0;
	;
    break;}
case 17:
#line 239 "idlparser.y"
{yyval.definition_list=iluparser_new_list();;
    break;}
case 24:
#line 249 "idlparser.y"
{ 
		yyval.definition_list=iluparser_new_list();
		deflist_insert(yyval.definition_list,yyvsp[0].definition);
	;
    break;}
case 25:
#line 254 "idlparser.y"
{	yyval.definition_list=yyvsp[-1].definition_list;deflist_insert(yyval.definition_list,yyvsp[0].definition);
	;
    break;}
case 27:
#line 258 "idlparser.y"
{yyval.name=yyvsp[0].name;yyvsp[0].name->scope=new_name();;
    break;}
case 28:
#line 259 "idlparser.y"
{yyval.name=yyvsp[0].name;yyval.name->scope=yyvsp[-2].name;;
    break;}
case 29:
#line 263 "idlparser.y"
{	yyval.name_list=iluparser_new_list();
		list_insert(yyval.name_list,yyvsp[0].name);
	;
    break;}
case 30:
#line 267 "idlparser.y"
{	yyval.name_list=yyvsp[-2].name_list;list_insert(yyval.name_list,yyvsp[0].name);
	;
    break;}
case 31:
#line 272 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=CONSTtag;
		yyval.definition->name=yyvsp[-2].name;
		yyval.definition->u.constant.type=yyvsp[-3].type;
		yyval.definition->u.constant.val=yyvsp[0].value;
		yyval.definition->u.constant.computed=FALSE;
	;
    break;}
case 41:
#line 289 "idlparser.y"
{
		yyval.type=new_referenced(yyvsp[0].name);
	;
    break;}
case 44:
#line 296 "idlparser.y"
{	yyval.value=new_binary(yyvsp[-2].value,'|',yyvsp[0].value);;
    break;}
case 46:
#line 300 "idlparser.y"
{	yyval.value=new_binary(yyvsp[-2].value,'^',yyvsp[0].value);;
    break;}
case 48:
#line 304 "idlparser.y"
{	yyval.value=new_binary(yyvsp[-2].value,'&',yyvsp[0].value);;
    break;}
case 50:
#line 307 "idlparser.y"
{	yyval.value=new_binary(yyvsp[-2].value,'L',yyvsp[0].value);;
    break;}
case 51:
#line 309 "idlparser.y"
{	yyval.value=new_binary(yyvsp[-2].value,'R',yyvsp[0].value);;
    break;}
case 53:
#line 312 "idlparser.y"
{	yyval.value=new_binary(yyvsp[-2].value,'+',yyvsp[0].value);;
    break;}
case 54:
#line 314 "idlparser.y"
{	yyval.value=new_binary(yyvsp[-2].value,'-',yyvsp[0].value);;
    break;}
case 56:
#line 317 "idlparser.y"
{	yyval.value=new_binary(yyvsp[-2].value,'*',yyvsp[0].value);;
    break;}
case 57:
#line 319 "idlparser.y"
{	yyval.value=new_binary(yyvsp[-2].value,'/',yyvsp[0].value);;
    break;}
case 58:
#line 321 "idlparser.y"
{	yyval.value=new_binary(yyvsp[-2].value,'%',yyvsp[0].value);;
    break;}
case 59:
#line 322 "idlparser.y"
{yyval.value=new_unary(yyvsp[-1].opname,yyvsp[0].value);;
    break;}
case 61:
#line 324 "idlparser.y"
{yyval.opname='+';;
    break;}
case 62:
#line 325 "idlparser.y"
{yyval.opname='-';;
    break;}
case 63:
#line 326 "idlparser.y"
{yyval.opname='~';;
    break;}
case 64:
#line 328 "idlparser.y"
{	yyval.value=new_value();yyval.value->tag=idl_named;
		yyval.value->u.named=yyvsp[0].name;
	;
    break;}
case 66:
#line 332 "idlparser.y"
{yyval.value=yyvsp[-1].value;;
    break;}
case 77:
#line 345 "idlparser.y"
{	char *s=iluparser_Malloc(strlen(yyvsp[-1].value->u.string)+
			strlen(yyvsp[0].value->u.string)+1);
		strcpy(s,yyvsp[-1].value->u.string);strcat(s,yyvsp[0].value->u.string);
		yyval.value=yyvsp[-1].value;
		yyval.value->u.string=s;
	;
    break;}
case 78:
#line 352 "idlparser.y"
{yyval.definition=yyvsp[0].definition;;
    break;}
case 82:
#line 357 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=TYPEtag;
		yyval.definition->name=yyvsp[0].name;
	  	yyval.definition->u.type=new_type();yyval.definition->u.type->tag=NATIVEtag;
	;
    break;}
case 83:
#line 363 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=TYPELISTtag;
		yyval.definition->u.typelist.type=yyvsp[-1].type;
		yyval.definition->u.typelist.names=yyvsp[0].name_list;
	;
    break;}
case 85:
#line 370 "idlparser.y"
{	yyval.type=new_type();yyval.type->tag=DEFINEDtag;
		yyval.type->u.defined=yyvsp[0].definition;
		yyval.type->name=yyvsp[0].definition->name;
	;
    break;}
case 88:
#line 378 "idlparser.y"
{
		yyval.type=new_referenced(yyvsp[0].name);
	;
    break;}
case 104:
#line 401 "idlparser.y"
{	yyval.name_list=iluparser_new_list();
		list_insert(yyval.name_list,yyvsp[0].name);
	;
    break;}
case 105:
#line 405 "idlparser.y"
{	yyval.name_list=yyvsp[-2].name_list;list_insert(yyval.name_list,yyvsp[0].name);;
    break;}
case 110:
#line 413 "idlparser.y"
{yyval.type=the_float_t;;
    break;}
case 111:
#line 414 "idlparser.y"
{yyval.type=the_double_t;;
    break;}
case 117:
#line 423 "idlparser.y"
{yyval.type=the_long_long_t;;
    break;}
case 118:
#line 424 "idlparser.y"
{yyval.type=the_long_t;;
    break;}
case 119:
#line 425 "idlparser.y"
{yyval.type=the_short_t;;
    break;}
case 123:
#line 430 "idlparser.y"
{yyval.type=the_unsigned_long_long_t;;
    break;}
case 124:
#line 431 "idlparser.y"
{yyval.type=the_unsigned_long_t;;
    break;}
case 125:
#line 432 "idlparser.y"
{yyval.type=the_unsigned_short_t;;
    break;}
case 126:
#line 434 "idlparser.y"
{yyval.type=the_char_t;;
    break;}
case 127:
#line 435 "idlparser.y"
{yyval.type=the_wchar_t;;
    break;}
case 128:
#line 436 "idlparser.y"
{yyval.type=the_boolean_t;;
    break;}
case 129:
#line 437 "idlparser.y"
{yyval.type=the_octet_t;;
    break;}
case 130:
#line 438 "idlparser.y"
{yyval.type=the_any_t;;
    break;}
case 131:
#line 439 "idlparser.y"
{yyval.type=the_object_t;;
    break;}
case 132:
#line 442 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=TYPEtag;
		yyval.definition->name=yyvsp[-3].name;
		yyval.definition->u.type=new_type();
		yyval.definition->u.type->tag=STRUCTtag;
		yyval.definition->u.type->has_scope=TRUE;
		yyval.definition->u.type->u.structure=yyvsp[-1].definition_list;
		yyval.definition->u.type->name=yyvsp[-3].name;
	;
    break;}
case 133:
#line 451 "idlparser.y"
{	yyval.definition_list=iluparser_new_list();deflist_insert(yyval.definition_list,yyvsp[0].definition);;
    break;}
case 134:
#line 453 "idlparser.y"
{	deflist_insert(yyvsp[-1].definition_list,yyvsp[0].definition);yyval.definition_list=yyvsp[-1].definition_list;;
    break;}
case 135:
#line 455 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=MEMBERLISTtag;
		yyval.definition->u.typelist.type=yyvsp[-2].type;
		yyval.definition->u.typelist.names=yyvsp[-1].name_list;
	;
    break;}
case 136:
#line 461 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=TYPEtag;
		yyval.definition->name=yyvsp[-7].name;
		yyval.definition->u.type=new_type();yyval.definition->u.type->tag=UNIONtag;
		yyval.definition->u.type->has_scope=TRUE;
		yyval.definition->u.type->u._union.head=yyvsp[-4].type;
		/* make identifiers in switch_type_spec visible */
		type_insert(yyvsp[-1].definition_list,yyvsp[-4].type);
		yyval.definition->u.type->u._union.body=yyvsp[-1].definition_list;
		yyval.definition->u.type->u._union._default=0;
	;
    break;}
case 142:
#line 478 "idlparser.y"
{	yyval.type=new_type();yyval.type->tag=DEFINEDtag;yyval.type->u.defined=yyvsp[0].definition;;
    break;}
case 143:
#line 480 "idlparser.y"
{	yyval.type=new_referenced(yyvsp[0].name);
	;
    break;}
case 144:
#line 484 "idlparser.y"
{	yyval.definition_list=iluparser_new_list();deflist_insert(yyval.definition_list,yyvsp[0].definition);;
    break;}
case 145:
#line 486 "idlparser.y"
{	yyval.definition_list=yyvsp[-1].definition_list;deflist_insert(yyval.definition_list,yyvsp[0].definition);;
    break;}
case 146:
#line 489 "idlparser.y"
{	yyval.definition=yyvsp[-1].definition;yyval.definition->u._case.labels=yyvsp[-2].caselabel_list;;
    break;}
case 147:
#line 492 "idlparser.y"
{	yyval.caselabel_list=iluparser_new_list();list_insert(yyval.caselabel_list,yyvsp[0].caselabel);;
    break;}
case 148:
#line 494 "idlparser.y"
{	yyval.caselabel_list=yyvsp[-1].caselabel_list;list_insert(yyval.caselabel_list,yyvsp[0].caselabel);;
    break;}
case 149:
#line 497 "idlparser.y"
{	yyval.caselabel=new_case();yyval.caselabel->value=yyvsp[-1].value;;
    break;}
case 150:
#line 499 "idlparser.y"
{	yyval.caselabel=new_case();;
    break;}
case 151:
#line 502 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=CASEtag;
		yyval.definition->name=yyvsp[0].name;
		yyval.definition->u._case.type=yyvsp[-1].type;
	;
    break;}
case 152:
#line 508 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=TYPEtag;
		yyval.definition->name=yyvsp[-3].name;
		yyval.definition->u.type=new_type();
		yyval.definition->u.type->tag=ENUMtag;
		yyval.definition->u.type->u.enumerated=yyvsp[-1].name_list;
	;
    break;}
case 153:
#line 515 "idlparser.y"
{	yyval.name_list=iluparser_new_list();list_insert(yyval.name_list,yyvsp[0].definition);;
    break;}
case 154:
#line 517 "idlparser.y"
{	yyval.name_list=yyvsp[-2].name_list;list_insert(yyval.name_list,yyvsp[0].definition);;
    break;}
case 155:
#line 519 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=ENUMVALtag;
		yyval.definition->name=yyvsp[0].name;
		yyval.definition->u.enumval=new_value();
		yyval.definition->u.enumval->tag=idl_enum;
		yyval.definition->u.enumval->u.enumerated.type=0;
		yyval.definition->u.enumval->u.enumerated.name=yyvsp[0].name;
	;
    break;}
case 156:
#line 528 "idlparser.y"
{	yyval.type=new_type();yyval.type->tag=SEQUENCEtag;
		yyval.type->u.sequence.size=yyvsp[-1].value;
		yyval.type->u.sequence.type=yyvsp[-3].type;
	;
    break;}
case 157:
#line 533 "idlparser.y"
{	yyval.type=new_type();yyval.type->tag=SEQUENCEtag;
		yyval.type->u.sequence.size=NULL;
		yyval.type->u.sequence.type=yyvsp[-1].type;
	;
    break;}
case 158:
#line 539 "idlparser.y"
{	yyval.type=new_type();yyval.type->tag=STRINGtag;yyval.type->u.stringsize=yyvsp[-1].value;;
    break;}
case 159:
#line 541 "idlparser.y"
{	yyval.type=the_string_t;;
    break;}
case 160:
#line 544 "idlparser.y"
{	yyval.type=new_type();yyval.type->tag=WSTRINGtag;yyval.type->u.stringsize=yyvsp[-1].value;;
    break;}
case 161:
#line 546 "idlparser.y"
{	yyval.type=new_type();yyval.type->tag=WSTRINGtag;yyval.type->u.stringsize=0;;
    break;}
case 162:
#line 549 "idlparser.y"
{	yyvsp[-1].name->array=iluparser_new_list();list_insert(yyval.name->array,yyvsp[0].value);
		yyval.name=yyvsp[-1].name;
	;
    break;}
case 163:
#line 553 "idlparser.y"
{	yyval.name=yyvsp[-1].name;list_insert(yyval.name->array,yyvsp[0].value);;
    break;}
case 164:
#line 555 "idlparser.y"
{yyval.value=yyvsp[-1].value;;
    break;}
case 165:
#line 558 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=ATTRIBUTEtag;
		yyval.definition->name=yyvsp[0].name;
		yyval.definition->u.attribute.readonly=yyvsp[-3].flag;
		yyval.definition->u.attribute.type=yyvsp[-1].type;
		yyval.definition->u.attribute.names=0;
	;
    break;}
case 166:
#line 565 "idlparser.y"
{	if(yyvsp[-2].definition->tag==ATTRIBUTEtag){
			yyvsp[-2].definition->tag=ATTRLISTtag;
			yyvsp[-2].definition->u.attribute.names=iluparser_new_list();
			list_insert(yyvsp[-2].definition->u.attribute.names,yyvsp[-2].definition->name);
			yyvsp[-2].definition->name=0;
		}
		yyval.definition=yyvsp[-2].definition;list_insert(yyvsp[-2].definition->u.attribute.names,yyvsp[0].name);
	;
    break;}
case 167:
#line 574 "idlparser.y"
{yyval.flag=FALSE;;
    break;}
case 168:
#line 575 "idlparser.y"
{yyval.flag=TRUE;;
    break;}
case 169:
#line 578 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=EXCEPTIONtag;
		yyval.definition->name=yyvsp[-3].name;
		yyval.definition->u.exception.members=yyvsp[-1].definition_list;
	;
    break;}
case 170:
#line 582 "idlparser.y"
{yyval.definition_list=0;;
    break;}
case 172:
#line 587 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=OPERATIONtag;
		yyval.definition->u.operation.oneway=yyvsp[-5].flag;
		yyval.definition->u.operation.returntype=yyvsp[-4].type;
		yyval.definition->name=yyvsp[-3].name;
		yyval.definition->u.operation.parameters=yyvsp[-2].definition_list;
		yyval.definition->u.operation.raises=yyvsp[-1].name_list;
		yyval.definition->u.operation.context=yyvsp[0].string_list;
	;
    break;}
case 173:
#line 596 "idlparser.y"
{yyval.flag=FALSE;;
    break;}
case 174:
#line 597 "idlparser.y"
{yyval.flag=TRUE;;
    break;}
case 176:
#line 600 "idlparser.y"
{yyval.type=the_void_t;;
    break;}
case 177:
#line 602 "idlparser.y"
{ yyval.definition_list=yyvsp[-1].definition_list;;
    break;}
case 178:
#line 604 "idlparser.y"
{	yyval.definition_list=iluparser_new_list();;
    break;}
case 179:
#line 607 "idlparser.y"
{ 	yyval.definition_list=iluparser_new_list();list_insert(yyval.definition_list,yyvsp[0].definition);;
    break;}
case 180:
#line 609 "idlparser.y"
{ list_insert(yyvsp[-2].definition_list,yyvsp[0].definition);yyval.definition_list=yyvsp[-2].definition_list;;
    break;}
case 181:
#line 612 "idlparser.y"
{	yyval.definition=new_definition();yyval.definition->tag=PARAMETERtag;
		yyval.definition->u.parameter.direction=yyvsp[-2].inout;
		yyval.definition->u.parameter.type=yyvsp[-1].type;
		yyval.definition->name=yyvsp[0].name;
	;
    break;}
case 182:
#line 618 "idlparser.y"
{yyval.inout=In;;
    break;}
case 183:
#line 619 "idlparser.y"
{yyval.inout=Out;;
    break;}
case 184:
#line 620 "idlparser.y"
{yyval.inout=InOut;;
    break;}
case 185:
#line 622 "idlparser.y"
{yyval.name_list=0;;
    break;}
case 186:
#line 623 "idlparser.y"
{yyval.name_list=yyvsp[-1].name_list;;
    break;}
case 187:
#line 625 "idlparser.y"
{yyval.string_list=0;;
    break;}
case 188:
#line 626 "idlparser.y"
{yyval.string_list=yyvsp[-1].string_list;;
    break;}
case 189:
#line 629 "idlparser.y"
{	yyval.string_list=iluparser_new_list();list_insert(yyval.string_list,yyvsp[0].value);;
    break;}
case 190:
#line 631 "idlparser.y"
{	yyval.string_list=yyvsp[-2].string_list;list_insert(yyval.string_list,yyvsp[0].value);;
    break;}
case 195:
#line 638 "idlparser.y"
{
		yyval.type=new_referenced(yyvsp[0].name);
	;
    break;}
case 196:
#line 643 "idlparser.y"
{	yyval.type=new_type();yyval.type->tag=FIXEDtag;
		yyval.type->u.fixed.digits=yyvsp[-3].value;
		yyval.type->u.fixed.fraction=yyvsp[-1].value;
	;
    break;}
case 197:
#line 648 "idlparser.y"
{yyval.type=the_fixed_t;;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyerror(error_message[yystate]);
#else
      yyerror("parse error");
#endif /* YYERROR_VERBOSE */
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 654 "idlparser.y"


/* Constructors */
IDLDefinition new_definition()
{
  IDLDefinition result;
  result=(IDLDefinition)iluparser_Malloc(sizeof(struct idl_definition));
  result->tag=NILtag;
  result->name=0;
  result->isl=0;
  result->env=0;
  result->prefix=0;
  result->id=0;
  result->version=0;
  return result;
}

IDLType new_type()
{
  IDLType result;
  result=(IDLType)iluparser_Malloc(sizeof(struct idl_type));
  result->tag=NULLTYPEtag;
  result->has_scope=FALSE;
  result->isl=NULL;
  result->name=NULL;
  result->anon_def=NULL;
  return result;
}

IDLName new_name()
{
  IDLName result=(IDLName)iluparser_Malloc(sizeof(struct idl_name));
  next_serial++;
  result->serial=next_serial;
  result->file=NULL;
  result->line=0;
  result->env=NULL;
  result->scope=NULL;
  result->name=NULL;
  result->lifted=NULL;
  result->value=NULL;
  result->array=NULL;
  result->no_ordering=0;
  return result;
}

IDLValue new_value()
{
  IDLValue result;
  result=(IDLValue)iluparser_Malloc(sizeof(struct idl_value));
  result->tag=idl_void;
  result->value=NULL;
  result->isl=NULL;
  return result;
}

IDLCase new_case()
{
  IDLCase result;
  result=(IDLCase)iluparser_Malloc(sizeof(struct idl_case));
  result->value=0;
  result->isl=0;
  return result;
}

/*********************** complex constructors ***************************/

IDLType new_referenced(IDLName n)
{		
  IDLType result=new_type();
  result->tag=REFERENCEDtag;
  result->u.referenced.name=n;
  result->u.referenced.val=0;
  return result;
}

IDLValue new_unary(char opname,IDLValue val)
{
  IDLValue result=new_value();
  result->tag=idl_unary;
  result->u.unary.operator=opname;
  result->u.unary.arg=val;
  return result;
}

IDLValue new_binary(IDLValue val1,char opname,IDLValue val2)
{
  IDLValue result=new_value();
  result->tag=idl_binary;
  result->u.binary.operator=opname;
  result->u.binary.arg1=val1;
  result->u.binary.arg2=val2;
  return result;
}

static boolean
is_anonymous(IDLType t)
{
  switch(t->tag){
  case FIXEDtag:
    /* this is not supported, yet */
  case WSTRINGtag:
    /* if there was an ilu.WString type, this would not be anonymous */
  case ARRAYtag:
  case SEQUENCEtag:
    return t->name==NULL;
  case STRINGtag:
    /* can use ilu.CString */
    if(t->u.stringsize)return t->name==NULL;
    return t->name==NULL;
  default:
    break;
  }
  return FALSE;
}

static void
declare_type(refany name,refany rock)
{
  refany *r=rock;
  IDLType t,t1;
  IDLDefinition d=new_definition();
  d->tag=TYPEtag;
  d->name=name;
  t=r[0];
  if(d->name->array){
    t1=new_type();
    t1->tag=ARRAYtag;
    t1->name=name;
    t1->u.array.type=t;
    t1->u.array.dimensions=d->name->array;
    d->name->array=0;
    t=t1;
  }else{
    /* this is a possible alias definition */
    if(is_anonymous(t))
      t->name=name;
    else{
      t1=new_type();
      t1->tag=ALIAStag;
      t1->name=name;
      t1->u.alias=t;
      t=t1;
    }
  }
  d->u.type=t;
  list_insert(r[1],d);
}
	
static void
declare_member(refany name,refany rock)
{
  refany *r=rock;
  IDLDefinition d=new_definition();
  d->tag=MEMBERtag;
  d->name=name;
  d->u.member=r[0];
  list_insert(r[1],d);
}

static void
declare_attribute(refany name,refany rock)
{
  refany *r=rock;
  IDLDefinition a=r[0];
  IDLDefinition d=new_definition();
  d->tag=ATTRIBUTEtag;
  d->name=name;
  d->u.attribute.type=a->u.attribute.type;
  d->u.attribute.readonly=a->u.attribute.readonly;
  d->u.attribute.names=0;
  list_insert(r[1],d);
}

void
type_insert(list l,IDLType t)
{
  if(t->tag!=DEFINEDtag)return;
  /* typedef struct foo{long bar;} foobar,baz; */
  deflist_insert(l,t->u.defined);
}

static void
declare_enum(refany e,refany rock)
{
  refany *r=rock;
  IDLDefinition d=e;
  d->u.enumval->u.enumerated.type=r[0];
  list_insert(r[1],e);
}

void deflist_insert(list l,IDLDefinition d)
{
  refany rock[2];
  switch(d->tag){
  case TYPELISTtag:
    type_insert(l,d->u.typelist.type);
    rock[0]=d->u.typelist.type;
    rock[1]=l;
    list_enumerate(d->u.typelist.names,declare_type,rock);
    break;
  case MEMBERLISTtag:
    type_insert(l,d->u.typelist.type);
    rock[0]=d->u.typelist.type;
    rock[1]=l;
    list_enumerate(d->u.typelist.names,declare_member,rock);
    break;
  case ATTRLISTtag:
    type_insert(l,d->u.attribute.type);
    rock[0]=d;
    rock[1]=l;
    list_enumerate(d->u.attribute.names,declare_attribute,rock);
    break;
  case TYPEtag:
    if(d->u.type->tag==ENUMtag){
      /* insert enum values as definitions */
      rock[0]=d->u.type;
      rock[1]=l;
      list_enumerate(d->u.type->u.enumerated,declare_enum,rock);
    }
  default:
    list_insert(l,d);
  }
}

static Type new_Type(void);
static TypeDescription new_TypeDescription(void);
static Name new_Name(void);

static void
primitive_setuid(Type T)
{
  if(!T->uid){
    char buf[100];
    FigureTypeUID(T);
    /* FIXME: work around FigureTypeUid setting the mark */
    sprintf(buf,"(%s)",type_name(T));
    name_set_lang_name(T->name,"parser:full",buf);
  }
}

static boolean
find_ilu_type(refany object,refany string)
{
  Type t=object;
  return strcmp(name_base_name(t->name),string)==0;
}

void init_types()
{
	IDLType v;
	Type t;
	TypeDescription d;
#define ADD_PRIMITIVE_TYPE(n)\
	v=the_##n##_t= new_type();\
	v->tag=BASICtag;\
	v->u.basic=idl_##n;

  ADD_PRIMITIVE_TYPES;

  /* need to get ilu before making a call to FigureTypeUID */
  the_ilu_module = GetInterface("ilu",0);

#undef ADD_PRIMITIVE_TYPE
#define ADD_PRIMITIVE_TYPE(n,str,tk)\
        v=the_##n##_t;\
	v->isl=t=new_Type();\
	t->description=d=new_TypeDescription();\
	d->type=tk;\
	t->builtIn=TRUE;\
	name_set_base_name(t->name,str);\
	primitive_setuid(t);

  ADD_PRIMITIVE_TYPE (short, "shortinteger", shortinteger_Type);
  ADD_PRIMITIVE_TYPE (long, "integer", integer_Type);
  ADD_PRIMITIVE_TYPE (long_long, "longinteger", longinteger_Type);
  ADD_PRIMITIVE_TYPE (unsigned_short, "shortcardinal", shortcardinal_Type);
  ADD_PRIMITIVE_TYPE (unsigned_long, "cardinal", cardinal_Type);
  ADD_PRIMITIVE_TYPE (unsigned_long_long, "longcardinal", longcardinal_Type);
  ADD_PRIMITIVE_TYPE (double, "real", real_Type);
  ADD_PRIMITIVE_TYPE (float, "shortreal", shortreal_Type);
  ADD_PRIMITIVE_TYPE (octet, "byte", byte_Type);
  ADD_PRIMITIVE_TYPE (boolean, "boolean", boolean_Type);
  ADD_PRIMITIVE_TYPE (char, "shortcharacter", shortcharacter_Type);
  ADD_PRIMITIVE_TYPE (wchar, "character", character_Type);
  ADD_PRIMITIVE_TYPE (any, "pickle", pickle_Type);

  /* not supported by IDL
  ADD_PRIMITIVE_TYPE ( "longreal", longreal_Type);
  */

  /* look for ilu.CORBA-Object */
  the_CORBA_Object = list_find(the_ilu_module->classes,
			       find_ilu_type,"CORBA-Object");
  the_ilu_CString = list_find(the_ilu_module->types,find_ilu_type,"CString");
  /* import this type */
  t=new_Type();
  t->name=new_Name();
  name_set_base_name(t->name,name_base_name(the_CORBA_Object->name));
  name_set_lang_name(t->name,"import","CORBA-Object");
  t->supertype=the_CORBA_Object;
  t->importInterfaceName = "ilu";
  t->interface=the_CORBA_Object->interface;
  t->uid=the_CORBA_Object->uid;
  the_CORBA_Object=t;
  the_object_t = new_type();
  the_object_t->tag=BASICtag;
  the_object_t->u.basic=idl_object;
  the_object_t->isl=the_CORBA_Object;

  the_string_t=new_type();
  the_string_t->tag=STRINGtag;
  the_string_t->u.stringsize=0;
  the_string_t->isl=t=new_Type();
  /* make this type an imported ilu.CString */
  t->name=new_Name();
  name_set_base_name(t->name,name_base_name(the_ilu_CString->name));
  name_set_lang_name(t->name,"import","CString");
  t->supertype=the_ilu_CString;
  t->importInterfaceName="ilu";
  t->interface=the_ilu_CString->interface;
  t->uid=the_ilu_CString->uid;

  the_fixed_t=new_type();
  the_fixed_t->tag=FIXEDtag;
  the_fixed_t->u.fixed.digits=0;
  the_fixed_t->u.fixed.fraction=0;
  /* FIXME: ISL for fixed types */
}

int idlerror(char *s)
{
#ifdef YYERROR_VERBOSE
  extern char *idltext;
  fprintf(stderr,"%s:%ld:parse error before '%s'\n%s\n",
	  idlcurrentfile(),(long)idlcurrentline(),idltext,s);
#else
  fprintf(stderr,"%s:%ld:%s\n",idlcurrentfile(),idlcurrentline(),s);
#endif
  return 0;
}

static void
name_warning(IDLName n,char *s)
{
  if(n)
    fprintf(stderr,"%s:%ld:%s:%s\n",n->file,(long)n->line,n->name,s);
  else
    fprintf(stderr,"<no line>:%s\n",s);
}

static void
name_error(IDLName n,char *s)
{
  name_warning(n,s);
  exit(1);
}

static char*
new_anon_type()
{
  static int anon_counter=0;
  return aprintf("AnonType-%d-",++anon_counter);
}

/********* Print functions **************************************/
static void 
name_print(FILE *f,IDLName n)
{
  if(n->scope){
    name_print(f,n->scope);
    fprintf(f,"::");
  }else if(n->name)
    fprintf(f,"%s",n->name);
  else
    fprintf(f,"::");
}

void definition_print(FILE* f,IDLDefinition d)
{
  char *n="unknown definition";
  if(d->env)
    definition_print(f,d->env);
  if(d->name && d->name->name)
    n=d->name->name;
  fprintf(f,"::%s",n);
}

/********* Converting to ISL ************************************/

/* copied from ilu.bison */
static Name new_Name(void)
{
  Name new = (Name) iluparser_Malloc (sizeof(struct name_s));
  new->base_name = NULL;
  new->langnames = (set) new_list();
  return (new);
}

static Exception new_Exception(void)
{
  Exception new = (Exception) iluparser_Malloc (sizeof(struct ilu_exception_s));
  new->name = new_Name();
#if HAVE_SCOPING
  new->scoping = iluparser_new_list();
#endif
  new->type = NULL;
  new->valueOptional = FALSE;
  new->refs = new_list();
  new->def = 0;
  new->id = 0;
  new->builtIn = FALSE;
  new->interface = NULL;
  new->importInterfaceName = NULL;
  new->import = NULL;
  new->marked = FALSE;
  new->corba_rep_id = NULL;
  new->doc_string = NULL;
  return (new);
}

static Type new_Type(void)
{
  Type new = (Type) iluparser_Malloc (sizeof(struct ilu_type_s));
#if HAVE_SCOPING
  new->scoping = iluparser_new_list();
#endif
  new->name = (Name) new_Name();
  new->description = NULL;
  new->supertype = NULL;
  new->refs = new_list();
  new->def = 0;
  new->builtIn = FALSE;
  new->importInterfaceName = NULL;
  new->interface = NULL;
  new->cached_des = NULL;
  new->marked = FALSE;
  new->uid = NULL;
  return (new);
}

static TypeDescription new_TypeDescription(void)
{
  TypeDescription new = (TypeDescription) iluparser_Malloc(sizeof(struct ilu_typedes_s));
  new->type = invalid_Type;
  memset((char *) new, 0, sizeof(struct ilu_typedes_s));
  return (new);
}

static Procedure new_Procedure(void)
{
  Procedure new = (Procedure) iluparser_Malloc (sizeof(struct ilu_proc_s));
  new->name = new_Name();
  new->object = NULL;
  new->arguments = NULL;
  new->returnType = NULL;
  new->returnOptional = FALSE;
  new->functional = FALSE;
  new->asynch = FALSE;
  new->exceptions = NULL;
  new->def = 0;
  new->id = -1;
  new->interface = NULL;
  new->marked = FALSE;
  /* added MvL */
  new->authentication_type = NULL;
  new->doc_string = NULL;
  return (new);
}

static Argument new_Argument(void)
{
  Argument new = (Argument) iluparser_Malloc (sizeof(struct ilu_argument_s));
  new->name = new_Name();
  new->type = NULL;
  new->values = NULL;
  new->def = 0;
  new->sibling = FALSE;
  new->direction = In;
  return (new);
}

/* end of copy */

static char*
underscore2hyphen(char *s)
{
  char *result=ilu_strdup(s);
  for(s=result;*s;s++)
    if(*s=='_')*s='-';
  return result;
}

/************************* Name lookup ***************************/

static IDLDefinition
up_find_definition(IDLDefinition d,enum idldefinition_tag t)
{
  while(d && d->tag!=t)
    d=d->env;
  return d;
}

static IDLDefinition
toplevel_module(IDLDefinition d)
{
  if(!d->env)return d;
  return toplevel_module(d->env);
}

static boolean
cmp_name(refany def,refany name)
{
  boolean result;
  IDLDefinition d=def;
  /* pragma prefix does not have a name */
  if(!d->name)return FALSE;
  if(d->name->scope)return FALSE;
  /* catch cases where it doesn't define something */
  switch(d->tag){
  case PRAGMA_PREFIXtag:
  case PRAGMA_IDtag:
  case PRAGMA_VERSIONtag:
  case INTERFACEFWDtag:
    return FALSE;
  default:
    break;
  }
  /* IDL is case-insensitive */
  result=ilu_strcasecmp(d->name->name,name)==0;
  /* check for consistent spelling */
  if(result && strcmp(d->name->name,name)!=0)
    name_error(d->name,aprintf(" is also spelled as '%s'.",name));
  return result;
}

struct lookup_base_s{
  char *name;
  list toplevel;
  IDLDefinition result;
  IDLDefinition def;
};

static IDLDefinition lookup_name(IDLDefinition d,char* n,list toplevel);

static void
lookup_base(refany name,refany rock)
{
  struct lookup_base_s *r=rock;
  IDLName n=name;
  IDLDefinition found=lookup_name(n->value,r->name,r->toplevel);
  if(r->result && found && r->result!=found){
    name_error(r->def->name,aprintf("ambiguous resolution for %s",r->name));
    return;
  }
  if(found)
    r->result=found;
}

static IDLDefinition
lookup_name(IDLDefinition d,char* n,list toplevel)
{
  IDLDefinition result=0;
  switch(d->tag){
  case MODULEtag:
    result=list_find(d->u.module.definitions,cmp_name,n);
    break;
  case INTERFACEtag:
    result=list_find(d->u.interface.definitions,cmp_name,n);
    if(!result){
      /* search bases */
      struct lookup_base_s s;
      s.name=n;
      s.toplevel=toplevel;
      s.result=0;
      s.def=d;
      list_enumerate(d->u.interface.bases,lookup_base,&s);
      result=s.result;
    }
    break;
  case OPERATIONtag:
    result=list_find(d->u.operation.parameters,cmp_name,n);
    break;
  case EXCEPTIONtag:
    result=list_find(d->u.exception.members,cmp_name,n);
    break;
  case TYPEtag:
    switch(d->u.type->tag){
    case STRUCTtag:
      result=list_find(d->u.type->u.structure,cmp_name,n);
      break;
    case UNIONtag:
      result=list_find(d->u.type->u._union.body,cmp_name,n);
      break;
    default:
      break;
    }
    break;
  /* inside the other definitions, there are no more names */
  default:
    break;
  }
  if(!result)
    if(!d->env)
      /* not found, need toplevel lookup */
      return list_find(toplevel,cmp_name,n);
    else 
      return lookup_name(d->env,n,toplevel);
  return result;
}

static boolean
find_imported(refany imported,refany name)
{
  return strcmp(((Imported)imported)->name,name)==0;
}

static void
add_import(IDLDefinition m,char *name,char *filename)
{
  Interface I=m->isl;
  Imported imp;
  assert(I);
  /* importing self? */
  if(strcmp(name,m->name->name)==0)
    return;
  if(!I->imports)
    I->imports=iluparser_new_list();
  if(list_find(I->imports,find_imported,name))
    return;
  imp=(Imported)iluparser_Malloc(sizeof(*imp));
  imp->name=name;
  imp->filename=filename;
  list_insert(I->imports,imp);
}

#if HAVE_SCOPING
static void
definition_setscoping(IDLDefinition d,list l)
{
  list_push(l,d->name->name);
  while(d->env){
    d=d->env;
    list_push(l,d->name->name);
  }
}
#endif

/************************** module reopening pass ******************/

static void list_insert1(refany i,refany l)
{
  list_insert(l,i);
}

static void find_duplicate_modules(refany def,refany l)
{
  IDLDefinition d=def;
  if(d->tag==MODULEtag){
    IDLDefinition first=list_find(l,cmp_name,d->name->name);
    if(first && first->tag==MODULEtag)
      /* insert definitions of def into first */
      list_enumerate(d->u.module.definitions,list_insert1,
		     first->u.module.definitions);
    else
      list_insert(l,d);
  }
  else
    /* add this definition */
    list_insert(l,d);
}

static list reopen_modules(list alt);

static void 
module_reopen_modules(refany def,refany rock)
{
  IDLDefinition d=def;
  if(d->tag!=MODULEtag)return;
  d->u.module.definitions=reopen_modules(d->u.module.definitions);
}
  

static list 
reopen_modules(list alt)
{
  list neu=iluparser_new_list();
  list_enumerate(alt,find_duplicate_modules,neu);
  list_enumerate(neu,module_reopen_modules,0);
  /* delete the old list, leaving the items in the new list */
  list_clear(alt,0);
  return neu;
}

/************************** backlink pass **************************/

static void definition_backlink(refany def,refany env);

static void
name_backlink(refany name,refany rock)
{
  IDLName n=name;
  while(n){
    n->env=rock;
    n=n->scope;
  }
}

static void
value_backlink(refany val,refany rock)
{
  IDLValue v=val;
  switch(v->tag){
  case idl_named:
    name_backlink(v->u.named,rock);
    break;
  case idl_unary:
    value_backlink(v->u.unary.arg,rock);
    break;
  case idl_binary:
    value_backlink(v->u.binary.arg1,rock);
    value_backlink(v->u.binary.arg2,rock);
    break;
  default:
    /* nothing to do for other value */
    break;
  }
}

static void
type_backlink(refany type,refany rock)
{
  IDLType t=type;
  switch(t->tag){
  case NULLTYPEtag:
  case BASICtag: 
  case NATIVEtag:
    break;
  case REFERENCEDtag:
    name_backlink(t->u.referenced.name,rock);
    break;
  case ALIAStag:
    type_backlink(t->u.alias,rock);
    break;
  case SEQUENCEtag:
    type_backlink(t->u.sequence.type,rock);
    if(t->u.sequence.size)
      value_backlink(t->u.sequence.size,rock);
    break;
  case STRUCTtag:
    list_enumerate(t->u.structure,definition_backlink,rock);
    break;
  case ENUMtag:
    break;
  case UNIONtag:
    type_backlink(t->u._union.head,rock);
    list_enumerate(t->u._union.body,definition_backlink,rock);
    break;
  case ARRAYtag:
    type_backlink(t->u.array.type,rock);
    list_enumerate(t->u.array.dimensions,value_backlink,rock);
    break;
  case WSTRINGtag:
  case STRINGtag:
    if(t->u.stringsize)
      value_backlink(t->u.stringsize,rock);
    break;
  case FIXEDtag:
    if(t->u.fixed.digits){
      value_backlink(t->u.fixed.digits,rock);
      value_backlink(t->u.fixed.fraction,rock);
    }
    break;
  case DEFINEDtag:
    definition_backlink(t->u.defined,rock);
    break;
  }
}

static void
case_backlink(refany Case,refany rock)
{
  IDLCase c=Case;
  IDLDefinition d=rock;
  c->env=d;
  if(c->value)
    value_backlink(c->value,d->env);
}

static void
definition_backlink(refany def,refany env)
{
  IDLDefinition d=def;
  d->env=env;
  if(d->name){
    d->prefix=env?aprintf("%s/%s",d->env->prefix,d->name->name):d->name->name;
    d->name->lifted=underscore2hyphen(d->name->name);
  }
  switch(d->tag){
    /* those should not happen */
  case NILtag:case TYPELISTtag:case MEMBERLISTtag:case ATTRLISTtag:
    break;
    /* those don't have nested items */
  case INTERFACEFWDtag:
    break;
  case MODULEtag:
    list_enumerate(d->u.module.definitions,definition_backlink,d);
    break;
  case INTERFACEtag:
    list_enumerate(d->u.interface.definitions,definition_backlink,d);
    /* base names are used in the environment of the interface */
    list_enumerate(d->u.interface.bases,name_backlink,d->env);
    break;
  case EXCEPTIONtag:
    list_enumerate(d->u.exception.members,definition_backlink,d);
    break;
  case CONSTtag:
    type_backlink(d->u.constant.type,d->env);
    value_backlink(d->u.constant.val,d->env);
    break;
  case ENUMVALtag:
    break;
  case OPERATIONtag:
    type_backlink(d->u.operation.returntype,d);
    list_enumerate(d->u.operation.parameters,definition_backlink,d);
    list_enumerate(d->u.operation.raises,name_backlink,d);
    if(d->u.operation.context)
      name_warning(d->name,"Context not supported");
    break;
  case ATTRIBUTEtag:
    type_backlink(d->u.attribute.type,d);
    break;
  case PARAMETERtag:
    type_backlink(d->u.parameter.type,d);
    break;
  case TYPEtag:
    if(d->u.type->has_scope)
      type_backlink(d->u.type,d);
    else
      type_backlink(d->u.type,d->env);
    break;
  case MEMBERtag:
    /* structure fields don't define a scope */
    type_backlink(d->u.member,d->env);
    break;
  case CASEtag:
    type_backlink(d->u._case.type,d->env);
    list_enumerate(d->u._case.labels,case_backlink,d);
    break;
  case PRAGMA_IDtag:
  case PRAGMA_VERSIONtag:
    name_backlink(d->name,env);
    break;
  case PRAGMA_PREFIXtag:
    break;
  }
}

/************************* resolvenames pass *************************/
static void definition_resolvenames(refany def,refany rock);

static boolean
find_fwd(refany def,refany name)
{
  IDLDefinition d=def;
  IDLName n=name;
  return d->tag==INTERFACEFWDtag && strcmp(n->name,d->name->name)==0;
}

static void
name_resolvenames(refany name,refany rock)
{
  IDLName n=name;
  if(n->scope){
    /* scoped name */
    if(n->scope->name){
      /* relative scope */
      name_resolvenames(n->scope,rock);
      n->value=lookup_name(n->scope->value,n->name,rock);
    }else
      /* absolute scope */
      n->value=list_find(rock,cmp_name,n->name);
  }else if(n->env)
    /* unscoped name used inside a scope */
    n->value=lookup_name(n->env,n->name,rock);
  else
    /* unscoped name used on the toplevel */
    n->value=list_find(rock,cmp_name,n->name);
  if(!n->value)
    name_error(n,"undefined");
  if(n->value->name->serial > n->serial && !n->no_ordering){
    /* this the value is an interface definition,
       a forward declaration would be enough.
       If the interface is used as a base interface,
       the caller will check it */
    if(n->value->tag==INTERFACEtag){
      IDLDefinition fwd,mod;
      mod=n->value->env;
      /* the interface is better in a module, if it is in something at all */
      if(mod && mod->tag!=MODULEtag)
	name_error(n,"Internal error, please report");
      if(mod)
	fwd=list_find(mod->u.module.definitions,find_fwd,n->value->name);
      else
	fwd=list_find(rock,find_fwd,n->value->name);
      if(!fwd)
	name_error(n,"missing forward declaration");
      if(fwd->name->serial > n->serial)
	name_error(n,"used before first forward declaration");
    }else
      /* the name is defined too late */
      name_error(n,"used before definition");
  }
}

static void
value_resolvenames(refany val,refany rock)
{
  IDLValue v=val;
  switch(v->tag){
  case idl_named:
    name_resolvenames(v->u.named,rock);
    break;
  case idl_unary:
    value_resolvenames(v->u.unary.arg,rock);
    break;
  case idl_binary:
    value_resolvenames(v->u.binary.arg1,rock);
    value_resolvenames(v->u.binary.arg2,rock);
    break;
  default:
    break;
  }
}

static void
type_resolvenames(refany type,refany rock)
{
  IDLType t=type;
  switch(t->tag){
  case NULLTYPEtag:
  case BASICtag:
  case NATIVEtag:
    break;
  case REFERENCEDtag:
    name_resolvenames(t->u.referenced.name,rock);
    break;
  case ALIAStag:
    type_resolvenames(t->u.alias,rock);
    break;
  case SEQUENCEtag:
    type_resolvenames(t->u.sequence.type,rock);
    if(t->u.sequence.size)
      value_resolvenames(t->u.sequence.size,rock);
    break;
  case STRUCTtag:
    list_enumerate(t->u.structure,definition_resolvenames,rock);
    break;
  case ENUMtag:
    break;
  case WSTRINGtag:
  case STRINGtag:
    if(t->u.stringsize)
      value_resolvenames(t->u.stringsize,rock);
    break;
  case FIXEDtag:
    if(t->u.fixed.digits){
      value_resolvenames(t->u.fixed.digits,rock);
      value_resolvenames(t->u.fixed.fraction,rock);
    }
    break;
  case UNIONtag:
    type_resolvenames(t->u._union.head,rock);
    list_enumerate(t->u._union.body,definition_resolvenames,rock);
    break;
  case ARRAYtag:
    type_resolvenames(t->u.array.type,rock);
    list_enumerate(t->u.array.dimensions,value_resolvenames,rock);
    break;
  case DEFINEDtag:
    definition_resolvenames(t->u.defined,rock);
    break;
  }
}

static void
case_resolvenames(refany Case,refany rock)
{
  IDLCase c=Case;
  if(c->value)
    value_resolvenames(c->value,rock);
}

static void
interface_resolvenames(refany name,refany rock)
{
  IDLName n=name;
  IDLDefinition d;
  name_resolvenames(n,rock);
  d=n->value;
  if(d->tag!=INTERFACEtag)
    name_error(n,"does not specify an interface");
  definition_resolvenames(d,rock);
}
 
static void
pragma_setversionid(IDLDefinition d,char *value,int do_id)
{
  switch(d->tag){
  case TYPEtag:
  case INTERFACEtag:
  case EXCEPTIONtag:
  case CONSTtag:
    if(do_id){
      if(d->id)
	name_error(d->name,"Duplicate ID");
      else d->id=value;
    }else{
      if(d->version)
	name_error(d->name,"Duplicate version");
      else d->version=value;
    }
    if(d->id && d->version)
      name_error(d->name,"Both repository ID and version assigned\n");
    break;
  case NILtag:case OPERATIONtag:case MODULEtag:case MEMBERtag:
  case PARAMETERtag:case ATTRIBUTEtag:
  case TYPELISTtag:case ATTRLISTtag:case MEMBERLISTtag:
  case CASEtag:case INTERFACEFWDtag:case ENUMVALtag:
  case PRAGMA_IDtag:case PRAGMA_VERSIONtag:case PRAGMA_PREFIXtag:
    name_error(d->name,do_id ? "Invalid assignment of repository ID":
	       "Invalid assignment of repository version");
  }
}

static void
definition_resolvenames(refany def,refany rock)
{
  IDLDefinition d=def;
  switch(d->tag){
    /* those should not happen */
  case NILtag:case TYPELISTtag:case MEMBERLISTtag:case ATTRLISTtag:
    break;
  case MODULEtag:
    list_enumerate(d->u.module.definitions,definition_resolvenames,rock);
    break;
  case INTERFACEtag:
    /* bases first, because local definitions might refer to bases */
    switch(d->u.interface.resolution_state){
    case 0:
      /* normal operation, resolve */
      d->u.interface.resolution_state=1;
      list_enumerate(d->u.interface.bases,interface_resolvenames,rock);
      d->u.interface.resolution_state=2;
      /* local definitions */
      list_enumerate(d->u.interface.definitions,definition_resolvenames,rock);
      break;
    case 1:
      /* oops, nested call */
      name_error(d->name,"Cycle in base interface resolution");
      break;
    default:break;
    }
    break;
  case CONSTtag:
    type_resolvenames(d->u.constant.type,rock);
    value_resolvenames(d->u.constant.val,rock);
    break;
  case ENUMVALtag:
    break;
  case OPERATIONtag:
    type_resolvenames(d->u.operation.returntype,rock);
    list_enumerate(d->u.operation.parameters,definition_resolvenames,rock);
    /* list_enumerate allows for NULL lists */
    list_enumerate(d->u.operation.raises,name_resolvenames,rock);
    break;
  case ATTRIBUTEtag:
    type_resolvenames(d->u.attribute.type,rock);
    break;
  case EXCEPTIONtag:
    list_enumerate(d->u.exception.members,definition_resolvenames,rock);
    break;
  case MEMBERtag:
    type_resolvenames(d->u.member,rock);
    break;
  case TYPEtag:
    type_resolvenames(d->u.type,rock);
    break;
  case PARAMETERtag:
    type_resolvenames(d->u.parameter.type,rock);
    break;
  case CASEtag:
    type_resolvenames(d->u._case.type,rock);
    list_enumerate(d->u._case.labels,case_resolvenames,rock);
    break;
  case INTERFACEFWDtag:
    /* The corresponding definition has to be an interface,
       and it must be defined in the same scope */
    if(d->env)
      d->name->value=lookup_name(d->env,d->name->name,rock);
    else
      d->name->value=list_find(rock,cmp_name,d->name->name);
    if(!d->name->value ||
       d->name->value->env!=d->env)
      name_error(d->name,"no interface for forward declaration");
    else if(d->name->value->tag!=INTERFACEtag)
      name_error(d->name,"corresponding definition is not an interface");
    break;
  case PRAGMA_PREFIXtag:
    break;
  case PRAGMA_VERSIONtag:
    name_resolvenames(d->name,rock);
    pragma_setversionid(d->name->value,d->u.pragma,FALSE);
    break;
  case PRAGMA_IDtag:
    name_resolvenames(d->name,rock);
    pragma_setversionid(d->name->value,d->u.pragma,TRUE);
    break;
  }
}

/************************* check pass        *************************/

static boolean 
identity(refany v1,refany v2)
{
  return v1==v2;
}

static IDLValue value_compute(IDLValue v,list start,IDLName n,IDLType target);
static void definition_check(refany def,refany rock);
static IDLType type_compute(IDLType t);
static void type_check(IDLType t,IDLName n);

static boolean
isint(enum idltk t)
{
  return t==idl_int || t==idl_octet
    || t==idl_short || t==idl_long || t==idl_long_long 
    || t==idl_unsigned_short || t==idl_unsigned_long || 
    t==idl_unsigned_long_long 
    ;
}

static boolean
isfloat(enum idltk t)
{
  return t==idl_float || t==idl_double;
}

static IDLValue
value_coerce(IDLValue v,IDLType t,IDLName n)
{
  IDLValue v1;
  if(t->tag==BASICtag && v->tag==t->u.basic)
    return v;
  if(t->tag==ENUMtag){
    if(v->tag!=idl_enum)
      name_error(n,"value is not enumerated"); 
    if(type_compute(v->u.enumerated.type)!=t)
      name_error(n,"value is of wrong enumeration");
    return v;
  }
  if(t->tag==STRINGtag || t->tag==WSTRINGtag){
    if(v->tag!=idl_string)
      name_error(n,"value is not a string");
    return v;
  }
  if(t->tag!=BASICtag)
    name_error(n,"Conversion into complex type not possible");
  if(isint(t->u.basic)){
    boolean ok;
    int I=v->u.INT;
    if(!isint(v->tag))
      name_error(n,"Value is not an integral type");
    switch(t->u.basic){
    case idl_octet:            ok= (      0 <= I) && (I<=0xFF);  break;
    case idl_short:            ok= (-0x8000 <= I) && (I<=0x7FFF);break;
    case idl_unsigned_short:   ok= (      0 <= I) && (I<=0xFFFF);break;
    case idl_long_long: /* FIXME: cannot check long long */
    case idl_long:             ok= 1;break;
    case idl_unsigned_long_long: /* FIXME: cannot check long long */
    case idl_unsigned_long:    ok= I>=0;break;
    default:
      name_error(0,"Unknown basic type");
    }
    if(!ok)
      name_error(n,"Value out of range");
    v1=new_value();
    *v1=*v;
    v1->tag=t->u.basic;
    return v1;
  }
  if(isfloat(t->u.basic)){
    if(!isfloat(v->tag))
      name_error(n,"Value is not floating point");
    /* FIXME: range check */
    v1=new_value();
    *v1=*v;
    v1->tag=t->u.basic;
    return v1;
  }
  if(t->u.basic==idl_boolean){
    if(v->tag!=idl_boolean)
      name_error(n,"Value is not boolean");
    return v;
  }
  if(t->u.basic==idl_char || t->u.basic==idl_wchar){
    if(v->tag!=idl_char)
      name_error(n,"Value is not a character");
    return v;
  }
  if(t->u.basic==idl_any)
    name_error(n,"Constants of type any are not allowed");
  name_error(n,"Unsupported type for constants");
  return 0;
}

static IDLValue
definition_compute(IDLDefinition d,list start,IDLName n)
{
  if(d->tag==ENUMVALtag)
    return d->u.enumval;
  if(d->u.constant.computed)
    return d->u.constant.val;
  if(list_find(start,identity,d))
    name_error(d->name,"cycle in computation of value");
  if(d->tag!=CONSTtag)
    name_error(n,aprintf("%s is not a constant",d->name->name));
  list_insert(start,d);
  d->u.constant.val=value_compute(d->u.constant.val,start,
				  d->name,type_compute(d->u.constant.type));
  d->u.constant.computed=TRUE;
  return d->u.constant.val;
}

static IDLValue
value_compute(IDLValue v,list start,IDLName n,IDLType target)
{
  IDLDefinition named;
  IDLValue v1,v2;
  if(v->value)
    return value_coerce(v->value,target,n);
  switch(v->tag){
  case idl_named:
    named=v->u.named->value;
    v->value=definition_compute(named,start,named->name);
    return value_coerce(v->value,target,n);
  case idl_unary:
    v1=value_compute(v->u.unary.arg,start,n,target);
    if(isint(v1->tag)){
      v->tag=v1->tag;
      switch(v->u.unary.operator){
      case '+':v->u.INT = v1->u.INT;break;
      case '-':v->u.INT =-v1->u.INT;break;
      case '~':v->u.INT =~v1->u.INT;break;
      default:
	name_error(n,"Invalid unary integer operator");
      }
    }else if(isfloat(v1->tag)){
      char op=v->u.unary.operator;
      *v=*v1;
      v->value=0;
      switch(op){
      case '+':break;
      case '-':
	v->u.FLOAT.val=-v->u.FLOAT.val;
	v->u.FLOAT.sign=!v->u.FLOAT.sign;
	break;
      default:
	name_error(n,"Invalid unary float operator");
      }
    }else
      name_error(n,"Invalid operand for unary operator");
    return value_coerce(v,target,n);
  case idl_binary:
    v1=value_compute(v->u.binary.arg1,start,n,target);
    v2=value_compute(v->u.binary.arg2,start,n,target);
    if(isint(v1->tag)){
      v->tag=v1->tag;
      switch(v->u.binary.operator){
	/* FIXME: integer overflow must be detected */
      case '+':v->u.INT = v1->u.INT + v2->u.INT;break;
      case '-':v->u.INT = v1->u.INT - v2->u.INT;break;
      case '*':v->u.INT = v1->u.INT * v2->u.INT;break;
      case '/':v->u.INT = v1->u.INT / v2->u.INT;break;
      case '%':v->u.INT = v1->u.INT % v2->u.INT;break;
      case 'L':v->u.INT = v1->u.INT <<v2->u.INT;break;
      case 'R':v->u.INT = v1->u.INT >>v2->u.INT;break;
      case '&':v->u.INT = v1->u.INT & v2->u.INT;break;
      case '^':v->u.INT = v1->u.INT ^ v2->u.INT;break;
      case '|':v->u.INT = v1->u.INT | v2->u.INT;break;
      default:
	name_error(n,"Invalid binary integer operator");
      }
    }else if(isfloat(v1->tag)){
      char op=v->u.binary.operator;
      v->tag=v1->tag;
      /* literal integral parts not supported here */
      v->u.FLOAT.integer=v->u.FLOAT.fraction=0;
      switch(op){
      case '+':v->u.FLOAT.val = v1->u.FLOAT.val + v2->u.FLOAT.val;break;
      case '-':v->u.FLOAT.val = v1->u.FLOAT.val - v2->u.FLOAT.val;break;
      case '*':v->u.FLOAT.val = v1->u.FLOAT.val * v2->u.FLOAT.val;break;
      case '/':v->u.FLOAT.val = v1->u.FLOAT.val / v2->u.FLOAT.val;break;
      default:
	name_error(n,"Invalid floating point binary operator");
      }
    }else
      name_error(n,"Invalid arguments for binary operators");
    return value_coerce(v,target,n);
  default:
    /* primitive values */
    return value_coerce(v,target,n);
  }
  return 0;
}

static IDLType
type_compute(IDLType t)
{
  switch(t->tag){
    /* those identify themselves */
  case NULLTYPEtag:case BASICtag:case SEQUENCEtag:case STRINGtag:
  case STRUCTtag:case ARRAYtag:case ENUMtag:case UNIONtag:case WSTRINGtag:
  case FIXEDtag:case NATIVEtag:
    return t;
    /* those is one of the above after one level of indirection */
  case DEFINEDtag:
    return type_compute(t->u.defined->u.type);
  case ALIAStag:
    return type_compute(t->u.alias);
  case REFERENCEDtag:
    if(t->u.referenced.val)
      return t->u.referenced.val;
    type_check(t,t->u.referenced.name);
    assert(t->u.referenced.val);
    return type_compute(t->u.referenced.val);
  }
  return 0;
}

static boolean
definition_isdefinition(IDLDefinition d)
{
  switch(d->tag){
  case PRAGMA_VERSIONtag:case PRAGMA_IDtag:case PRAGMA_PREFIXtag:
  case INTERFACEFWDtag:
    return FALSE;
  default:
    return TRUE;
  }
}

static void
duplicate_check(refany def1,refany def)
{
  IDLDefinition d1=def1,d=def;
  /* identical definitions, no problem */
  if(def1==def)return;
  /* one or the other does not really define anything */
  if(!definition_isdefinition(d) || !definition_isdefinition(d1))
    return;
  /* different names, no problem */
  if(!cmp_name(d,d1->name->name))return;
  /* for same names, only complain if def is after def1 */
  if(d->name->line<d1->name->line)return;
  name_error(d->name,aprintf("already defined in line %d\n",d1->name->line));
}

static void
dimensions_check(refany val,refany name)
{
  IDLValue v=val;
  list l;
  *v=*value_compute(val,l=iluparser_new_list(),name,the_long_t);
  if(v->u.INT<=0)
    name_error(name,"dimension is not positive");
  /* free temporary list */
  list_clear(l,FALSE);
  iluparser_Free(l);
}

static IDLType
type_resolve(IDLType t,list l,IDLName n)
{
  IDLDefinition d;
  if(t->tag!=REFERENCEDtag)return t;
  if(t->u.referenced.val)return t->u.referenced.val;
  d=t->u.referenced.name->value;
  if(d->tag==INTERFACEtag)
    /* referenced interface */
    return t;
  if(d->tag!=TYPEtag){
    name_error(n,aprintf("%s does not specify a type",d->name->name));
    return 0;
  }
  if(list_find(l,identity,d))
    name_error(n,"cycle in type resolution");
  list_insert(l,d);
  return d->u.type=type_resolve(d->u.type,l,n);
}

static void
type_check(IDLType t,IDLName n)
{
  list l=0;
  switch(t->tag){
  case NULLTYPEtag:
    /* this should not happen */
  case BASICtag:case ENUMtag:case NATIVEtag:
    /* nothing to do */
  case ALIAStag:case DEFINEDtag:
    /* those will be checked separately */
    break;
  case REFERENCEDtag:
    if(t->u.referenced.val)break;
    t->u.referenced.val=type_resolve(t,l=iluparser_new_list(),n);
    break;
  case SEQUENCEtag:
    type_check(t->u.sequence.type,n);
    if(t->u.sequence.size){
      t->u.sequence.size=
	value_compute(t->u.sequence.size,l=iluparser_new_list(),n,the_long_t);
      if(t->u.sequence.size->u.INT<=0)
	name_error(n,"sequence size is not positive");
    }
    break;
  case STRUCTtag:
    list_enumerate(t->u.structure,definition_check,0);
    break;
  case WSTRINGtag:
  case STRINGtag:
    if(t->u.stringsize){
      t->u.stringsize=
	value_compute(t->u.stringsize,l=iluparser_new_list(),n,the_long_t);
      if(t->u.stringsize->u.INT<=0)
	name_error(n,"string size is not positive");
    }
    break;
  case ARRAYtag:
    type_check(t->u.array.type,n);
    list_enumerate(t->u.array.dimensions,dimensions_check,n);
    break;
  case FIXEDtag:
    if(t->u.fixed.digits){
      list l1;
      t->u.fixed.digits=
	value_compute(t->u.fixed.digits,l=iluparser_new_list(),n,the_long_t);
      t->u.fixed.fraction=
	value_compute(t->u.fixed.fraction,l1=iluparser_new_list(),
		      n,the_long_t);
      if(t->u.fixed.digits->u.INT<=0)
	name_error(n,"number of digits not positive");
      list_clear(l1,FALSE);
      iluparser_Free(l1);
      /* l will be cleared below */
    }
    break;
  case UNIONtag:
    type_check(t->u._union.head,n);
    list_enumerate(t->u._union.body,definition_check,0);
    break;
  }
  if(l){
    /* free temporary list */
    list_clear(l,FALSE);
    iluparser_Free(l);
  }
}

static void
caselabel_check(refany label,refany Union)
{
  IDLCase c=label;
  IDLDefinition u=Union;
  IDLName n=c->env->name;
  list l;
  if(c->value){
    c->value=value_compute(c->value,l=iluparser_new_list(),
			   n,type_compute(u->u.type->u._union.head));
    list_clear(l,FALSE);
    iluparser_Free(l);
  }else{ /*default*/
      IDLName n1=u->u.type->u._union._default;
      if(n1 && n!=n1)
	name_error(n,aprintf("default branch already assigned to %s",
			     n1->name));
      else
	u->u.type->u._union._default=n;
  }
}

/* compare location of base interface definition with this interface */
static void
definition_precedes(refany base,refany derived)
{
  IDLName d=derived;
  IDLName b=base;
  if(b->value->name->serial >= d->serial)
    name_error(d,"base interface must precede derived one");
}

/* merge an operation in l, complain if it is already there */
static void
collect_operations1(refany def,refany l)
{
  IDLDefinition d=def;
  IDLDefinition d1;
  if(d->tag!=OPERATIONtag)return;
  if((d1=list_find(l,cmp_name,d->name->name)))
    name_error(d->name,aprintf("When defining interface %s, "
			       "operation conflicts with interface %s\n",
			       /*FIXME: find name for base interface */
			       "with multiple interfaces",
			       d1->env->name->name));
  else
    list_insert(l,d);
}
			       
/* merge the definitions of one base interface into l */
static void
collect_operations(refany base,refany l)
{
  IDLName b=base;
  list_enumerate(b->value->u.interface.definitions,collect_operations1,l);
}

static void 
definition_check(refany def,refany rock)
{
  IDLDefinition d=def;
  list l=0;
  list_enumerate(rock,duplicate_check,d);
  switch(d->tag){
  case NILtag:case TYPELISTtag:case MEMBERLISTtag:case ATTRLISTtag:
    /* this should not happen */
    break;
  case PRAGMA_IDtag:case PRAGMA_VERSIONtag:case PRAGMA_PREFIXtag:
    /* nothing to do */
    break;
  case MODULEtag:
    list_enumerate(d->u.module.definitions,definition_check,
		   d->u.module.definitions);
    break;
  case INTERFACEtag:
    /* base interfaces must appear before derived */
    list_enumerate(d->u.interface.bases,definition_precedes,d->name);
    /* base interfaces must not share operation names */
    l=iluparser_new_list();
    list_enumerate(d->u.interface.bases,collect_operations,l);
    /* recurse */
    list_enumerate(d->u.interface.definitions,definition_check,
		   d->u.interface.definitions);
    break;
  case INTERFACEFWDtag:
    break;
  case EXCEPTIONtag:
    /* FIXME: check members */
    break;
  case CONSTtag:
    /* FIXME: type_check(d->u.constant*/
    definition_compute(d,l=iluparser_new_list(),d->name);
    break;
  case TYPEtag:
    type_check(d->u.type,d->name);
    break;
  case OPERATIONtag:
    break;
  case PARAMETERtag:
    type_check(d->u.parameter.type,d->name);
    break;
  case CASEtag:
    type_check(d->u._case.type,d->name);
    list_enumerate(d->u._case.labels,caselabel_check,d->env);
    break;
  case ATTRIBUTEtag:
    type_check(d->u.attribute.type,d->name);
    break;
  case MEMBERtag:
    type_check(d->u.member,d->name);
    break;
  case ENUMVALtag:
    break;
  }
  if(l){
    /* free list */
    list_clear(l,FALSE);
    iluparser_Free(l);
  }
}

/************************* setuid pass       *************************/

static char*
makeid(IDLDefinition d,char *prefix,char *version)
{
  return aprintf("IDL:%s%s%s:%s",
		 prefix?prefix:"",prefix?"/":"",
		 d->prefix,version?version:"1.0");
}

static void definition_setuid(refany def,refany cur);

static void
type_setuid(IDLType t,char **prefix)
{
  switch(t->tag){
    /* those don't have anything with uids inside */
  case NULLTYPEtag:
  case BASICtag:
  case REFERENCEDtag:
  case ENUMtag:
  case ALIAStag:
  case NATIVEtag:
    break;
    /* FIXME: anonymous types don't get a repository id, yet */
  case ARRAYtag:
  case SEQUENCEtag:
  case STRINGtag:
  case WSTRINGtag:
  case FIXEDtag:
    break;
  case UNIONtag:
    type_setuid(t->u._union.head,prefix);
    list_enumerate(t->u._union.body,definition_setuid,prefix);
    break;
  case STRUCTtag:
    list_enumerate(t->u.structure,definition_setuid,prefix);
    break;
  case DEFINEDtag:
    definition_setuid(t->u.defined,prefix);
    break;
  }
}

static void
definition_setuid(refany def,refany cur)
{
  char *newprefix=*(char**)cur;
  IDLDefinition d=def;
  switch(d->tag){
  case NILtag:case TYPELISTtag:case ATTRLISTtag:case MEMBERLISTtag:
    name_error(d->name,"Unexpected case in definition_setuid");
    break;
    /* those don't have anything with uids inside */
  case INTERFACEFWDtag:case PARAMETERtag:case MEMBERtag:case CONSTtag:
  case ENUMVALtag:case CASEtag:    

    break;
  case MODULEtag:
    list_enumerate(d->u.module.definitions,definition_setuid,&newprefix);
    break;
  case PRAGMA_PREFIXtag:
    *(char**)cur=d->u.pragma;
    break;
  case INTERFACEtag:
    list_enumerate(d->u.interface.definitions,definition_setuid,&newprefix);
    break;
  case TYPEtag:
    type_setuid(d->u.type,&newprefix);
    break;
  case EXCEPTIONtag:
    list_enumerate(d->u.exception.members,definition_setuid,&newprefix);
    break;
    /* those don't have repository ids */
  case OPERATIONtag:
  case ATTRIBUTEtag:
  case PRAGMA_IDtag:
  case PRAGMA_VERSIONtag:
    return;
  }
  if(!d->id)
    d->id=makeid(d,*(char**)cur,d->version);
}

/************************* maketoplevel      *************************/

static boolean
find_nonmodules(refany def,refany rock)
{
  IDLDefinition d=def;
  IDLDefinition r=rock;
  switch(d->tag){
    /* those are OK on toplevel */
  case PRAGMA_IDtag:case PRAGMA_VERSIONtag:case PRAGMA_PREFIXtag:
  case MODULEtag:
    return FALSE;
  default:
    return r ? (d->name->file==r->name->file):1;
  }
}

static void
make_toplevel(struct idl_parse *P)
{
  IDLDefinition d,m;
  char *s,*name;
  do{
    d=list_find(P->definitions,find_nonmodules,0);
    if(!d)break;
    m=new_definition();
    m->tag=MODULEtag;
    m->name=new_name();
    m->name->name=name=iluparser_basename(d->name->file);
    /* make sure this is a valid identifier */
    while(*name && !isalpha(*name))
      name++;
    if(!*name)
      name_error(d->name,"source file contains no letters");
    /* if it doesn't start with a letter, copy it */
    if(name!=m->name->name){
      s=m->name->name;
      m->name->name=ilu_strdup(name);
      iluparser_Free(s);
    }
    /* find the first invalid character */
    for(s=m->name->name;*s && (isalnum(*s) || *s=='_');s++)
      ;
    if(*s)*s='\0';
    m->name->lifted=underscore2hyphen(m->name->name);
    m->name->file=d->name->file;
    name_warning(m->name,"warning: introducing module");
    m->u.module.definitions=iluparser_new_list();
    list_insert(P->definitions,m);
    while(d){
      list_insert(m->u.module.definitions,d);
      definition_backlink(d,m);
      list_remove(P->definitions,d);
      d=list_find(P->definitions,find_nonmodules,m);
    }
  }while(1);
}

/************************* lift pass         *************************/

struct lifter{
  char *prefix;
  list lifted;
};

static void
lift_prefix(refany def,refany lift)
{
  IDLDefinition d=def;
  struct lifter *l=lift;
  d->name->lifted=aprintf("%s-%s",l->prefix,d->name->lifted);
  list_insert(l->lifted,d);
}

static void
definition_lift(refany def,refany rock)
{
  IDLDefinition d=def;
  struct lifter l;
  boolean do_lift=FALSE;
  if(!d->name)
    return;
  l.prefix=underscore2hyphen(d->name->name);
  l.lifted=iluparser_new_list();
  switch(d->tag){
  case MODULEtag:
    /* don't lift names directly inside the toplevel module */
    list_enumerate(d->u.module.definitions,definition_lift,d->env?&l:0);
    do_lift=1;
    break;
  case INTERFACEtag:
    list_enumerate(d->u.interface.definitions,definition_lift,&l);
    do_lift=1;
    break;
  case EXCEPTIONtag:
    do_lift=1;
    list_enumerate(d->u.exception.members,definition_lift,&l);
    break;
  case TYPEtag:
    do_lift=1;
    switch(d->u.type->tag){
    case STRUCTtag:
      list_enumerate(d->u.type->u.structure,definition_lift,&l);
      break;
    case UNIONtag:
      list_enumerate(d->u.type->u._union.body,definition_lift,&l);
      break;
    default:break;
    }
    break;
  case CONSTtag:
    do_lift=1;
    break;
  default:
    break;
  }
  /* lift myself as well */
  if(do_lift)
    list_insert(l.lifted,d);
  if(rock)
    list_enumerate(l.lifted,lift_prefix,rock);
  iluparser_Free(l.prefix);
  /* free list */
  list_clear(l.lifted,FALSE);
  iluparser_Free(l.lifted);
}

/************************* makeisl pass      *************************/

static void module_makeisl(IDLDefinition d);
static void interface_makeisl(IDLDefinition d);
static void operation_makeisl(IDLDefinition d);
static void typedef_makeisl(IDLDefinition d);
static void member_makeisl(IDLDefinition d);
static void parameter_makeisl(IDLDefinition d);
static void exception_makeisl(IDLDefinition d);
static void case_makeisl(IDLDefinition d);
static void const_makeisl(IDLDefinition d);
static void attribute_makeisl(IDLDefinition d);
static void value_makeisl(IDLValue v);
static void type_makeisl(IDLType p,IDLDefinition env);

static void
definition_makeisl(refany definition,refany rock)
{
  IDLDefinition d=definition;
  switch(d->tag){
    /* those should not happen */
  case NILtag:case TYPELISTtag:case MEMBERLISTtag:case ATTRLISTtag:
    break;
    /* those don't have ISL */
  case INTERFACEFWDtag:
    break;
  case MODULEtag:
    module_makeisl(d);
    break;
  case INTERFACEtag:
    interface_makeisl(d);
    break;
  case EXCEPTIONtag:
    exception_makeisl(d);
    break;
  case CONSTtag:
    const_makeisl(d);
    break;
  case ENUMVALtag:
    break;
  case OPERATIONtag:
    operation_makeisl(d);
    break;
  case ATTRIBUTEtag:
    attribute_makeisl(d);
    break;
  case TYPEtag:
    typedef_makeisl(d);
    break;
  case MEMBERtag:
    member_makeisl(d);
    break;
  case CASEtag:
    case_makeisl(d);
    break;
  case PARAMETERtag:
    parameter_makeisl(d);
    break;
  case PRAGMA_PREFIXtag:
  case PRAGMA_VERSIONtag:
  case PRAGMA_IDtag:
    break;
  }
}

static void
module_makeisl(IDLDefinition d)
{
  Interface new;
  if(d->env==NULL){
    /* toplevel module */
    d->isl=new=(Interface)iluparser_Malloc(sizeof(struct ilu_interface_s));
    new->name=new_Name();
    name_set_base_name(new->name,d->name->lifted);
    new->def=d->name->line;
    new->types=(set)iluparser_new_list();
    new->classes=(set)iluparser_new_list();
    new->imports=iluparser_new_list();    
    /* make sure the module knows about the ilu INTERFACE */
    add_import(d,"ilu",NULL);
    new->exceptions=(set)iluparser_new_list();
    new->constants=(set)iluparser_new_list();
    new->brand=NULL;
    new->def=0;
  }
  if(d->u.module.definitions)
    list_enumerate(d->u.module.definitions,definition_makeisl,d);
}

static void
interface_makeisl(IDLDefinition d)
{
  TypeDescription new;
  Type isl;
  new=new_TypeDescription();
  new->type=object_Type;
  new->structuredDes.object=iluparser_Malloc(sizeof(struct ilu_class_s));
  new->structuredDes.object->brand = NULL;
  new->structuredDes.object->corba_rep_id = d->id;
  new->structuredDes.object->collectible = FALSE;
  /* IDL interfaces are always optional */
  new->structuredDes.object->optional = TRUE;
  new->structuredDes.object->singleton = NULL;
  new->structuredDes.object->superclasses = NULL;
  new->structuredDes.object->authentication = NULL;
  new->structuredDes.object->methods = NULL;
  new->structuredDes.object->doc_string = NULL;

  d->isl=isl=new_Type();
  isl->def=d->name->line;
#if HAVE_SCOPING
  definition_setscoping(d,isl->scoping);
#endif

  isl->description=new;
  isl->interface=toplevel_module(d)->isl;
  /* ISL has the types in reverse order. In order to generate the
     same stub code, items are inserted at front */
  list_push(isl->interface->types,isl);
  /* FixupInterface will add them to the classes list later on
  list_push(isl->interface->classes,isl);*/
  name_set_base_name(isl->name,d->name->lifted);
  
  assert(d->u.interface.definitions);
  list_enumerate(d->u.interface.definitions,definition_makeisl,d);
} 

static void
operation_makeisl(IDLDefinition d)
{
  Class C;
  Procedure new=new_Procedure();
  assert(d->name->scope==NULL);
  d->isl=new;
  name_set_base_name(new->name,d->name->lifted);
  new->def=d->name->line;
  /* IDL operations are never functional */
  new->functional = FALSE;
  new->asynch = d->u.operation.oneway;
  new->interface = toplevel_module(d)->isl;
  /* add parameters */
  new->arguments=iluparser_new_list();
  list_enumerate(d->u.operation.parameters,definition_makeisl,0);
  type_makeisl(d->u.operation.returntype,d);
  /* link with interface/CLASS */
  new->object = up_find_definition(d,INTERFACEtag)->isl;
  C=new->object->description->structuredDes.object;
  if(!C->methods)
    C->methods=iluparser_new_list();
  list_insert(C->methods,new);
  /* FIXME: context */
}

static void
fill_array_dimensions(refany val,refany list)
{
  IDLValue v=val;
  assert(v->tag==idl_long);
  /* Hmm. Casting integers to pointers */
  list_insert(list,(refany)(v->u.INT));
}

static void
enum_makeisl(refany def,refany list)
{
  IDLDefinition d=def;
  EnumField f=iluparser_Malloc(sizeof(struct enumerationField_s));
  f->name=d->name->lifted;
  f->id=-1;
  list_insert(list,f);
}

static void
typedef_makeisl(IDLDefinition d)
{
  Type T;
  TypeDescription D;
  IDLType t;
  list l;
  t=d->u.type;
  d->isl=T=new_Type();
  if(!t->isl)
    t->isl=d->isl;
  T->description=D=new_TypeDescription();
  assert(d->name->name);
  assert(d->name->array==0);
  name_set_base_name(T->name,d->name->lifted);
#if HAVE_SCOPING
  definition_setscoping(d,T->scoping);
#endif
  T->def = d->name->line;
  T->interface = toplevel_module(d)->isl;
  list_push(T->interface->types,T);
  switch(t->tag){
    /* those should not happen */
  case NULLTYPEtag:case REFERENCEDtag:case BASICtag:
    break;
  case STRUCTtag:
    D->type=record_Type;
    D->structuredDes.record=iluparser_new_list();
    list_enumerate(t->u.structure,definition_makeisl,0);
    break;
  case ENUMtag:
    D->type=enumeration_Type;
    D->structuredDes.enumeration=l=iluparser_new_list();
    list_enumerate(t->u.enumerated,enum_makeisl,l);
    break;
  case UNIONtag:
    D->type=union_Type;
    D->structuredDes.uniond.discriminator_type=0;
    D->structuredDes.uniond.types=iluparser_new_list();
    D->structuredDes.uniond.default_arm=NULL;
    /* In CORBA, all values of the switch type are valid,
       even if they are not specified in the cases - 
       unless there is a default arm */
    D->structuredDes.uniond.others_allowed=TRUE;
    list_enumerate(t->u._union.body,definition_makeisl,0);
    break;
  case ARRAYtag:
    D->type=array_Type;
    D->structuredDes.array.type=0; /* update later */
    D->structuredDes.array.dimensions=l=iluparser_new_list();
    list_enumerate(t->u.array.dimensions,fill_array_dimensions,l);
    D->structuredDes.array.optional=FALSE;
    type_makeisl(t->u.array.type,d);
    /* for the dimensions, no special isl is necessary */
    break;
  case STRINGtag:
    if(t->u.stringsize){
      D->type=sequence_Type;
      D->structuredDes.sequence.type=the_char_t->isl;
      D->structuredDes.sequence.optional=TRUE;
      D->structuredDes.sequence.limit=t->u.stringsize->u.INT;
    }else{
      /* alias for ilu.CString */
      T->description=NULL;
      iluparser_Free(D);
      T->supertype=t->isl;
      /*name_set_lang_name(T->name,"import","CString");*/
    }
    break;
  case WSTRINGtag:
    D->type=sequence_Type;
    D->structuredDes.sequence.type=the_wchar_t->isl;
    D->structuredDes.sequence.optional=TRUE;
    if(t->u.stringsize)
      D->structuredDes.sequence.limit=t->u.stringsize->u.INT;
    else
      D->structuredDes.sequence.limit=0;
    break;
  case SEQUENCEtag:
    D->type=sequence_Type;
    D->structuredDes.sequence.type=0; /* update later */
    D->structuredDes.sequence.optional=TRUE;
    if(t->u.sequence.size)
      D->structuredDes.sequence.limit=t->u.sequence.size->u.INT;
    else
      D->structuredDes.sequence.limit=0;
    type_makeisl(t->u.sequence.type,d);
    break;
  case ALIAStag:
    T->description=NULL;
    iluparser_Free(D);
    if(is_anonymous(t->u.alias))
      type_makeisl(t->u.alias,d);
    break;
  case DEFINEDtag:
    /* this is an alias type */
    T->description=NULL;
    iluparser_Free(D);
    definition_makeisl(t->u.defined,0);
    break;
  case FIXEDtag:
    /* FIXME: implement */
    name_error(d->name,"fixed point types not supported, yet");
    break;
  case NATIVEtag:
    name_error(d->name,"native types not supported, yet");
    break;
  }
}

static void 
member_makeisl(IDLDefinition d)
{
  Argument A=new_Argument();
  Type T;
  name_set_base_name(A->name,d->name->lifted);
  A->def=d->name->line;
  assert(d->isl==0);
  d->isl=A;
  switch(d->env->tag){
  case TYPEtag:
    /* record type */
    T=d->env->isl;
    break;
  case EXCEPTIONtag:
    /* pseudo record for exceptions */
    T=((Exception)d->env->isl)->type;
    break;
  default:
    name_error(d->name,"unexpected scope for member");
  }
  list_insert(T->description->structuredDes.record,A);
  type_makeisl(d->u.type,d);
}

static void
parameter_makeisl(IDLDefinition d)
{
  Argument A=new_Argument();
  Procedure P=d->env->isl;

  A->direction=d->u.parameter.direction;
  name_set_base_name(A->name,d->name->lifted);
  A->def=d->name->line;
  type_makeisl(d->u.parameter.type,d);
  /* this might not succeed if the type is referenced */
  list_insert(P->arguments,A);
  d->isl=A;
}

/* anonymous type */
static void
anon_type(IDLType p,IDLDefinition env)
{
  IDLDefinition d=new_definition();
  d->name=p->name=new_name();
  /* name and lifted name are identical (no scoping, no underscores) */
  d->name->lifted=d->name->name=new_anon_type();
  d->name->file=env->name->file;
  d->name->line=env->name->line;
  d->tag=TYPEtag;
  d->env=env;
  d->u.type=p;
  p->anon_def=d;
  definition_makeisl(d,0);
  p->isl=d->isl;
}

static void
type_makeisl(IDLType p,IDLDefinition env)
{
  IDLDefinition d;
  Type T;
  if(p->isl)return;
  switch(p->tag){
    /* those should not happen */
  case NULLTYPEtag:case STRUCTtag:case ENUMtag:case UNIONtag:
    name_error(d->name,"Unexpected type");
    break;
  case BASICtag:
    /* no isl needs to be make here */
    break;
  case REFERENCEDtag:
    /* have to wait until after makeisl to locate the correct isl
       if this is an imported type, make the subtype */
    if(toplevel_module(env)->isl
       !=toplevel_module(p->u.referenced.name->value)->isl){
      Interface I;
      d=p->u.referenced.name->value;
      p->isl=T=new_Type();
      name_set_base_name(T->name, d->name->lifted);
      name_set_lang_name(T->name, "import", d->name->lifted);
      I=toplevel_module(env)->isl;
      list_push(I->types,T);
      /* supertype, importInterfaceName and interface added later */
    }
    break;
  case ALIAStag:
    type_makeisl(p->u.alias,env);
    break;
  case DEFINEDtag:
    /* nothing to do here: the struct/union definition 
       is in the defition list */
    break;
  case SEQUENCEtag:
    if(!p->name)
      anon_type(p,env);
    type_makeisl(p->u.sequence.type,env);
    break;
  case ARRAYtag:
    if(!p->name)
      anon_type(p,env);
    type_makeisl(p->u.array.type,env);
    break;
  case WSTRINGtag:
    anon_type(p,env);
    type_makeisl(the_wchar_t,env);
    break;
  case STRINGtag:
    if(!p->name && p->u.stringsize){
      anon_type(p,env);
      type_makeisl(the_char_t,env);
    }
    break;
  case NATIVEtag:
    break;
  case FIXEDtag:
    name_error(env->name,"fixed types not supported");
    break;
  }
}

static void
exception_makeisl(IDLDefinition d)
{
  Exception E=new_Exception();
  d->isl=E;
  name_set_base_name(E->name,d->name->lifted);
#if HAVE_SCOPING
  definition_setscoping(d,E->scoping);
#endif
  E->def=d->name->line;
  E->interface=toplevel_module(d)->isl;
  list_insert(E->interface->exceptions,E);
  /* if this has parameters, set type to a RECORD */
  if(d->u.exception.members){
    Type T;
    TypeDescription D;
    E->type=T=new_Type();
    T->description=D=new_TypeDescription();
    name_set_base_name(T->name,aprintf("ilu--prefix-idlExceptionType-%s",
				       d->name->lifted));
#if HAVE_SCOPING
    definition_setscoping(d,T->scoping);
#endif
    T->def=d->name->line;
    T->interface=toplevel_module(d)->isl;
    list_push(T->interface->types,T);
    D->type=record_Type;
    D->structuredDes.record=iluparser_new_list();
    list_enumerate(d->u.exception.members,definition_makeisl,0);
  }
}

static void
caselabel_makeisl(refany Case,refany arg)
{
  IDLCase c=Case;
  Argument A=arg;
  if(c->value){
    value_makeisl(c->value);
    c->isl=c->value->isl;
    list_insert(A->values,c->isl);
  }else{
    /* default: */
    IDLDefinition d=c->env->env;
    Type T;
    assert(d && d->tag==TYPEtag && d->u.type->tag==UNIONtag);
    T=d->isl;
    T->description->structuredDes.uniond.default_arm=A;
    T->description->structuredDes.uniond.others_allowed=FALSE;
  }
}

static void
case_makeisl(IDLDefinition d)
{
  Type T;
  Argument A=d->isl=new_Argument();
  name_set_base_name(A->name,d->name->lifted);
  A->values=iluparser_new_list();
  A->def=d->name->line;
  type_makeisl(d->u._case.type,d);
  /* insert labels */
  A->values=iluparser_new_list();
  list_enumerate(d->u._case.labels,caselabel_makeisl,A);
  /* insert case into union */
  T=d->env->isl;
  list_insert(T->description->structuredDes.uniond.types,A);
}

static void
value_makeisl(IDLValue v)
{
  ConstantValue V;
  boolean isint=FALSE,issigned=FALSE;
  if(v->isl)return;
  V=v->isl=iluparser_Malloc(sizeof(struct ilu_constantvalue_s));
  switch(v->tag){
    /* those should not happen */
  case idl_void:case idl_unary:case idl_binary:case idl_named:case idl_any:
  case idl_object:
    name_error(0,"unexpected value in makeisl");
    break;
    /* in the ISL, they are all integer_Type */
  case idl_short:
  case idl_long:
  case idl_long_long:
    isint=TRUE;issigned=TRUE;break;
  case idl_octet:
  case idl_unsigned_short:
  case idl_unsigned_long:
  case idl_unsigned_long_long:
    isint=TRUE;break;
  case idl_string:
    V->type=shortcharacter_Type;
    V->val.s=v->u.string;
    break;
  case idl_enum:
    V->type=shortcharacter_Type;
    V->val.s=v->u.enumerated.name->lifted;
    break;
  case idl_float:case idl_double:
    V->type=real_Type;
    if(v->u.FLOAT.integer || v->u.FLOAT.fraction){
      V->val.r.sign=v->u.FLOAT.sign;
      V->val.r.value=v->u.FLOAT.integer;
      V->val.r.fraction=v->u.FLOAT.fraction;
      V->val.r.exponent=v->u.FLOAT.exponent;
    }else{
      /* FIXME: What is the precision for double? */
      char *buf=aprintf("%.17E",v->u.FLOAT.val);
      char *p,*p1;
      p=buf;
      if(*p=='-'){
	V->val.r.sign=1;
	p++;
      }else V->val.r.sign=0;
      p1=strchr(p,'.');
      V->val.r.value=strndup(p,p1-p);
      p=p1+1;
      p1=strchr(p,'E');
      V->val.r.fraction=strndup(p,p1-p);
      V->val.r.exponent=strtol(p1+1,0,10);
      free(buf);
    }
    break;
  case idl_char:
    /* FIXME: should use character arm */
    V->type=shortinteger_Type;
    V->val.i.sign=0;
    V->val.i.value=v->u.CHAR;
    break;
  case idl_wchar:
    V->type=shortinteger_Type;
    V->val.i.sign=0;
    V->val.i.value=v->u.CHAR;
    break;
  case idl_boolean:
    V->type=boolean_Type;
    V->val.b=v->u.BOOL;
    break;
  case idl_int:
    name_error(0,"Untyped integer");
    break;
  }
  if(isint){
    V->type=integer_Type;
    if(issigned){
      V->val.i.sign=v->u.INT<0;
      V->val.i.value=v->u.INT<0?-v->u.INT:v->u.INT;
    }else{
      V->val.i.sign=0;
      V->val.i.value=v->u.INT;
    }
  }
}

static void
const_makeisl(IDLDefinition d)
{
  Constant C=iluparser_Malloc(sizeof(struct ilu_constant_s));
  d->isl=C;
  C->name=new_Name();
#if HAVE_SCOPING
  C->scoping = iluparser_new_list();
  definition_setscoping(d,C->scoping);
#endif
  name_set_base_name(C->name,d->name->lifted);
  C->def=d->name->line;
  C->interface=toplevel_module(d)->isl;
  list_insert(C->interface->constants,C);
  C->type=0;
  C->importInterfaceName=0;
  C->import=0;
  value_makeisl(d->u.constant.val);
  C->value=d->u.constant.val->isl;
}

static Procedure
attr_get_set(IDLDefinition d,boolean get)
{
  /* see operation_makeisl */
  Class C;
  Procedure new=new_Procedure();
  name_set_base_name(new->name,aprintf("ilu--prefix-idlAttribute--%s-%s",
				       get?"get":"set",d->name->lifted));
  new->def=d->name->line;
  new->functional=FALSE;
  new->asynch=FALSE;
  new->interface=toplevel_module(d)->isl;
  new->arguments=iluparser_new_list();
  if(get){
    /* add return type later */
  }else{
    Argument A=new_Argument();
    name_set_base_name(A->name,"value");
    A->direction=In;
    A->def=d->name->line;
    /* add parameter type later */
    list_insert(new->arguments,A);
  }
  type_makeisl(d->u.attribute.type,d);
  new->object = up_find_definition(d,INTERFACEtag)->isl;
  C=new->object->description->structuredDes.object;
  if(!C->methods)C->methods=iluparser_new_list();
  list_insert(C->methods,new);
  return new;
}
static void
attribute_makeisl(IDLDefinition d)
{
  /* make pseudo-operations */
  d->isl=attr_get_set(d,TRUE);
  if(!d->u.attribute.readonly)
    d->u.attribute.set=attr_get_set(d,FALSE);
}

/************************* update pass       *************************/

static void definition_update(refany def,refany rock);
static void typedef_update(IDLDefinition d);

static void
interface_insertsuper(refany name,refany def)
{
  IDLName n=name;
  IDLDefinition d=def;
  Type T=d->isl;
  Class C=T->description->structuredDes.object;
  IDLDefinition super=n->value;

  assert(super);
  if(toplevel_module(d)==toplevel_module(super)){
    /* insert ISL supertype into ISL superclasses list */
    list_insert(C->superclasses,super->isl);
  }else{
    /* make subtype */
    IDLDefinition m1,m2;
    Type T=new_Type();
    name_set_base_name(T->name,super->name->lifted);
    name_set_lang_name(T->name,"import",super->name->lifted);
    m1=toplevel_module(d);
    m2=toplevel_module(super);
    T->importInterfaceName=m2->name->lifted;
    /* import INTERFACE of supertype into this INTERFACE */
    add_import(m1,m2->name->lifted,m2->name->file);
    list_insert(((Interface)m1->isl)->types,T);
    list_insert(C->superclasses,T);
  }
}

static void
method_assignid(refany method,refany rock)
{
  Procedure p=method;
  int* pid=rock;
  p->id= ++*pid;
}

static void
interface_update(IDLDefinition d)
{
  Type T;
  Class C;
  int id=0;
  T=d->isl;
  C=T->description->structuredDes.object;
  assert(C->superclasses==NULL);
  C->superclasses=iluparser_new_list();
  if(d->u.interface.bases){
    list_enumerate(d->u.interface.bases,interface_insertsuper,d);
  }else{
    /* implicit superclass ilu.CORBA-Object */
    list_insert(C->superclasses,the_CORBA_Object);
  }
  list_enumerate(d->u.interface.definitions,definition_update,0);
  /* FIXME: should really call ilu.bison->AssignMethodIDs here */
  list_enumerate(C->methods,method_assignid,&id);
  /* assign repository IDs */
}

static void
type_update(IDLType t)
{
  IDLDefinition d;
  Type T;
  switch(t->tag){
    /* those should not happen */
  case NULLTYPEtag:case STRUCTtag:case ENUMtag:case UNIONtag:case NATIVEtag:
    name_error(0,"unexpected case in type_update");
    break;
    /* nothing to be done */
  case BASICtag:
  case WSTRINGtag:
  case STRINGtag:
    break;
  case REFERENCEDtag:
    {
      IDLDefinition m1,m2;
      d=t->u.referenced.name->value;
      assert(d && (d->tag==TYPEtag ||d->tag==INTERFACEtag));
      if(d->tag==TYPEtag)
	typedef_update(d);
      m1=toplevel_module(t->u.referenced.name->env);
      m2=toplevel_module(t->u.referenced.name->value);
      if(m1!=m2){
	/* imported type */
	T=t->isl;
	T->supertype=d->isl;
	T->importInterfaceName=m2->name->lifted;
	T->interface=m2->isl;
	add_import(m1,m2->name->lifted,m2->name->file);
      }else
	t->isl=d->isl;
    }
    break;
  case ALIAStag:
    if(t->isl)break;
    type_update(t->u.alias);
    t->isl=t->u.alias->isl;
    break;
  case DEFINEDtag:
    definition_update(t->u.defined,0);
    t->isl=t->u.defined->isl;
    break;
  case SEQUENCEtag:
  case ARRAYtag:
    if(t->anon_def)
      definition_update(t->anon_def,0);
    break;
  case FIXEDtag:
    break;
  }
}

static void
parameter_update(refany param)
{
  IDLDefinition p=param;
  Argument A=p->isl;
  assert(p->tag==PARAMETERtag);
  assert(A);
  type_update(p->u.parameter.type);
  A->type=p->u.parameter.type->isl;
}

static void
exc_update(refany exc,refany list)
{
  IDLName n=exc;
  IDLDefinition d=n->value;

  assert(d && d->isl);
  list_insert(list,d->isl);
}

static void
operation_update(IDLDefinition d)
{
  Procedure P=d->isl;

  assert(d->u.operation.returntype);
  type_update(d->u.operation.returntype);
  assert(P);
  P->returnType=d->u.operation.returntype->isl;
  list_enumerate(d->u.operation.parameters,definition_update,0);
  if(d->u.operation.raises){
    P->exceptions=iluparser_new_list();
    list_enumerate(d->u.operation.raises,exc_update,P->exceptions);
  }
  /* FIXME: context */
}

static void
typedef_update(IDLDefinition d)
{
  IDLType t=d->u.type;
  Type T=d->isl;
  /* The Type's uid indicates that this typedef is uptodate */
  if(T->uid)return;
  /* will be overwritten below #if idl2isl compatible*/
  T->uid=d->id;
  switch(t->tag){
    /* those should not happen */
  case NULLTYPEtag:case REFERENCEDtag:case NATIVEtag:
    name_error(d->name,"Unexpected case in typedef_update");
    break;
  case WSTRINGtag:
  case STRINGtag:
  case BASICtag:
    /* this sets the uid for the basic type */
    type_update(t);
    break;
  case SEQUENCEtag:
    type_update(t->u.sequence.type);
    assert(t->u.sequence.type->isl);
    T->description->structuredDes.sequence.type=t->u.sequence.type->isl;
    break;
  case STRUCTtag:
    list_enumerate(t->u.structure,definition_update,0);
    break;
  case ENUMtag:
    break;
  case UNIONtag:
    type_update(t->u._union.head);
    T->description->structuredDes.uniond.discriminator_type=
      t->u._union.head->isl;
    list_enumerate(t->u._union.body,definition_update,0);
    break;
  case ARRAYtag:
    type_update(t->u.array.type);
    assert(t->u.array.type->isl);
    T->description->structuredDes.array.type=t->u.array.type->isl;
    break;
  case FIXEDtag:
    break;
  case ALIAStag:
    type_update(t->u.alias);
    T->supertype=t->u.alias->isl;
    break;
  case DEFINEDtag:
    definition_update(t->u.defined,0);
    assert(t->u.defined->isl);
    T->supertype=t->u.defined->isl;
    break;
  }
#if LOCAL_TYPES_HAVE_REP_IDS
#else
  T->uid=0;
  if(t->tag==SEQUENCEtag || t->tag==ARRAYtag 
     || t->tag==WSTRINGtag || (t->tag==STRINGtag && t->u.stringsize!=0))
    /* typedef sequence<t>, typedef long */
    FigureTypeUID(T);
  else
    /* struct, union */
    T->uid=d->id;
#endif
}

static void
member_update(IDLDefinition d)
{
  Argument A=d->isl;
  type_update(d->u.type);
  assert(d->u.type->isl);
  A->type=d->u.type->isl;
}

static void
exception_update(IDLDefinition d)
{
  Exception E=d->isl;
  Type T=E->type;
  list_enumerate(d->u.exception.members,definition_update,0);
  E->corba_rep_id=d->id;
  if(T)
    T->uid=E->corba_rep_id;
}

static void
const_update(IDLDefinition d)
{
  Constant C=d->isl;
  type_update(d->u.constant.type);
  C->type=d->u.constant.type->isl;
}

static void
attribute_update(IDLDefinition d)
{
  Procedure P;
  type_update(d->u.attribute.type);
  P=d->isl;
  P->returnType=d->u.attribute.type->isl;
  if(!d->u.attribute.readonly){
    Argument A;
    P=d->u.attribute.set;
    A=list_car(P->arguments);
    A->type=d->u.attribute.type->isl;
  }
}

static void
case_update(IDLDefinition d)
{
  Argument A=d->isl;
  type_update(d->u._case.type);
  A->type=d->u._case.type->isl;
}

static void
definition_update(refany def,refany rock)
{
  IDLDefinition d=def;
  switch(d->tag){
    /* those should not happen */
  case NILtag:case TYPELISTtag:case MEMBERLISTtag:case ATTRLISTtag:
    break;
  case MODULEtag:
    list_enumerate(d->u.module.definitions,definition_update,rock);
    break;
  case INTERFACEtag:
    interface_update(d);
    break;
  case CONSTtag:
    const_update(d);
    break;
  case ENUMVALtag:
    break;
  case EXCEPTIONtag:
    exception_update(d);
    break;
  case OPERATIONtag:
    operation_update(d);
    break;
  case ATTRIBUTEtag:
    attribute_update(d);
    break;
  case PARAMETERtag:
    parameter_update(d);
    break;
  case TYPEtag:
    typedef_update(d);
    break;
  case MEMBERtag:
    member_update(d);
    break;
  case CASEtag:
    case_update(d);
    break;
    /* nothing to do */
  case INTERFACEFWDtag:
  case PRAGMA_IDtag:
  case PRAGMA_PREFIXtag:
  case PRAGMA_VERSIONtag:
    break;
  }
}

static void
select_imported(refany def,refany parse)
{
  struct idl_parse *p=parse;
  IDLDefinition d=def;
  if(d->tag!=MODULEtag)
    /* #pragma */
    return;
  if(strcmp(d->name->file,p->file)==0)
    list_insert(p->defined_interfaces,d->isl);
  else
    list_insert(p->imported_interfaces,d->isl);
}

static void
IDL2ISL(struct idl_parse *P)
{
  char *cur;
  /* join modules for re-opening */
  P->definitions=reopen_modules(P->definitions);
  /* backlink, toplevel has no parent */
  list_enumerate(P->definitions,definition_backlink,0);
  /* resolve all names */
  list_enumerate(P->definitions,definition_resolvenames,P->definitions);
  /* perform consistency checks, compute constants */
  list_enumerate(P->definitions,definition_check,P->definitions);
  /* assign repository IDs */
  cur=0;
  list_enumerate(P->definitions,definition_setuid,&cur);
  /* put everything in a module */
  make_toplevel(P);
  /* lift local types etc. to module level */
  list_enumerate(P->definitions,definition_lift,0);
  /* attach an ISL structure everywhere */
  list_enumerate(P->definitions,definition_makeisl,0);
  /* update ISL */
  list_enumerate(P->definitions,definition_update,0);
  /* select modules of toplevel source file */
  list_enumerate(P->definitions,select_imported,P);
}

list ParseIDLFile (struct idl_parse* P)
{
  int stat;
  extern FILE* idlin;

  extern int idl_flex_debug;
  static int initial=1;
  /* default: debugging is off */
  idl_flex_debug=0;
  if(initial){
    init_types();
    initial=0;
  }else{
    fprintf(stderr,"ParseIDLFile invoked twice (for %s)\n",P->file);
    return 0;
  }
  if ((idlin = fopen(P->file, "r")) == NULL)
    {
      fprintf (stderr, "ParseFile:  Error opening file \"%s\" for read.\n", P->file);
      return (NULL);
    }
  idlsetinitialfile(P->file);
  stat = idlparse();

  if(stat)return 0;

  P->defined_interfaces=iluparser_new_list();
  P->imported_interfaces=iluparser_new_list();
  P->definitions=the_result;
  IDL2ISL(P);

  return P->defined_interfaces;
}

#if HAVE_STRNDUP
#else
char* strndup(char* src,int n)
{
  char *result=iluparser_Malloc(n+1);
  strncpy(result,src,n);
  return result;
}
#endif

/* this should go into pathname.c */
char*
iluparser_basename(char* fullname)
{
  char *result,*h;
#if defined(WIN32) || defined(WIN16)
  for(result=fullname;(h=strpbrk(result,"/\\:"));result=h+1)
    /*nothing*/;
#elif defined(macintosh)
  for(result=fullname;(h=strchr(result,":"));result=h+1)
    ;
#else
  for(result=fullname;(h=strchr(result,'/'));result=h+1)
    ;
#endif
  return ilu_strdup(result);
}
