/* genarr.h (definitions for genarr.c) */
/* Chris Jacobi, December 30, 1996 3:10 pm PST */

/*
 * Copyright (c) 1991-1996 Xerox Corporation.  All Rights Reserved.
 * Unlimited use, reproduction, and distribution of this software is permitted.
 * Any copy of this software must include both the above copyright notice of
 * Xerox Corporation and this paragraph.  Any distribution of this software
 * must comply with all applicable United States export control laws.  This
 * software is made available AS IS, and XEROX CORPORATION DISCLAIMS ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND
 * NOTWITHSTANDING ANY OTHER PROVISION CONTAINED HEREIN, ANY LIABILITY FOR
 * DAMAGES RESULTING FROM THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED,
 * WHETHER ARISING IN CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT
 * LIABILITY, EVEN IF XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGES.
 */
 
/* $Id: genarr.h,v 1.2 1996/12/31 01:08:54 jacobi Exp $ */
 

     
extern boolean ar_is_a(Type t);
extern Type ar_assert(Type t);

extern char * ar_typeDeclarator(Type t);

extern char * ar_ioSzPiece(Type t, const char *arg);
extern char * ar_ioOutPiece(Type t, const char *arg);
extern char * ar_ioInPiece(Type t);

extern void ar_defineMain(Type t);

/* end */
