/* genenum.h (definitions for genenum.c) */
/* Chris Jacobi, January 23, 1997 4:19 pm PST */

/*
 * Copyright (c) 1991-1996 Xerox Corporation.  All Rights Reserved.
 * Unlimited use, reproduction, and distribution of this software is permitted.
 * Any copy of this software must include both the above copyright notice of
 * Xerox Corporation and this paragraph.  Any distribution of this software
 * must comply with all applicable United States export control laws.  This
 * software is made available AS IS, and XEROX CORPORATION DISCLAIMS ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND
 * NOTWITHSTANDING ANY OTHER PROVISION CONTAINED HEREIN, ANY LIABILITY FOR
 * DAMAGES RESULTING FROM THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED,
 * WHETHER ARISING IN CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT
 * LIABILITY, EVEN IF XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGES.
 */
 
/* $Id: genenum.h,v 1.1 1997/01/24 01:34:55 jacobi Exp $ */
 
     
extern boolean enm_is_a(Type t);
extern Type enm_assert(Type t);

extern char * enm_typeDeclarator(Type t);

extern char * enm_ioSzPiece(Type t, const char *arg);
extern char * enm_ioOutPiece(Type t, const char *arg);
extern char * enm_ioInPiece(Type t);

extern void enm_defineMain(Type t);

extern char * enumerationJavaClass(Type t);
    /* the class; whether it is the type or not... !!! */
    
extern char * enumerationInt(Type t, ConstantValue v);
    /* the __toInt value of the enumeration const !!! */

/* end */
