/* genobj.h (definitions for genobj.c) */
/* Chris Jacobi, August 18, 1997 6:54 pm PDT */

/*
 * Copyright (c) 1991-1996 Xerox Corporation.  All Rights Reserved.
 * Unlimited use, reproduction, and distribution of this software is permitted.
 * Any copy of this software must include both the above copyright notice of
 * Xerox Corporation and this paragraph.  Any distribution of this software
 * must comply with all applicable United States export control laws.  This
 * software is made available AS IS, and XEROX CORPORATION DISCLAIMS ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND
 * NOTWITHSTANDING ANY OTHER PROVISION CONTAINED HEREIN, ANY LIABILITY FOR
 * DAMAGES RESULTING FROM THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED,
 * WHETHER ARISING IN CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT
 * LIABILITY, EVEN IF XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGES.
 */
 
/* $Id: genobj.h,v 1.3 1997/08/20 21:52:43 jacobi Exp $ */
 
     
extern boolean obj_is_a(Type t);
extern Type obj_assert(Type t);

extern char * obj_typeDeclarator(Type t);

extern char * obj_ioSzPiece(Type t, const char *arg);
extern char * obj_ioOutPiece(Type t, const char *arg);
extern char * obj_ioInPiece(Type t);

extern void obj_defineMain(Type t);

extern boolean isCorbaDotObject(Type t);
extern void init_genobj();

/* end */
