/* genunion.h ;  defs for genunion.c */
/* Chris Jacobi, December 27, 1996 11:14 am PST */

/*
 * Copyright (c) 1991-1996 Xerox Corporation.  All Rights Reserved.
 * Unlimited use, reproduction, and distribution of this software is permitted.
 * Any copy of this software must include both the above copyright notice of
 * Xerox Corporation and this paragraph.  Any distribution of this software
 * must comply with all applicable United States export control laws.  This
 * software is made available AS IS, and XEROX CORPORATION DISCLAIMS ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND
 * NOTWITHSTANDING ANY OTHER PROVISION CONTAINED HEREIN, ANY LIABILITY FOR
 * DAMAGES RESULTING FROM THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED,
 * WHETHER ARISING IN CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT
 * LIABILITY, EVEN IF XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGES.
 */
 
/* $Id: genunion.h,v 1.4 1996/12/28 00:15:00 jacobi Exp $ */

extern boolean un_is_a(Type t);
extern Type un_assert(Type t);

extern char * un_typeDeclarator(Type t);

extern char * un_ioSzPiece(Type t, const char *arg);
extern char * un_ioOutPiece(Type t, const char *arg);
extern char * un_ioInPiece(Type t);

extern void un_defineMain(Type t);

/* end */
