/* TestServer.java */
/* Chris Jacobi, August 20, 1997 2:49 pm PDT */
/* $Id: TestServer.java,v 1.3 1997/08/20 21:51:01 jacobi Exp $ */

package somepackage; 

class TestServer {
  
    static xerox.ilu.IluServer trueServer;
    static PickleFactoryImpl factory;
    
    TestServer(){}
    
    static void handleOut() {
        try {
            //
            System.out.println("Starting a server");
            trueServer = xerox.ilu.IluServer.createServer("JavaPiTeServer");
            System.out.println("Server created");
            //
            factory = new PickleFactoryImpl("MyJarFile.jar");
            testjavaserial.PickleFactoryStub.registerTrueObject( 
                "myFactory", 
                factory, 
                trueServer
                );
            xerox.ilu.IluSimpleBinding.publish(factory);
            System.out.println("Factory instance published");
            String sbh = xerox.ilu.Ilu.sbhOfObject(factory);
            System.out.println("Its SBH is '" + sbh + "'");
            //
        } catch (xerox.ilu.IluSystemException e) {
            System.err.println("Caught an ilu exception: " + e );
        }
    } //handleOut

    public static void main(String argv[]) {
        System.out.println("Start TestServer");
        javaserial.JavaPickle.load();
        testjavaserial._allJavaStubs.load();
        System.out.println("junk loaded");
        handleOut();
    } //main

} //TestServer


class PickleFactoryImpl implements testjavaserial.PickleFactory {
    
    String path = null;
    javaserial.Accessor accessor = null;
    
    public PickleFactoryImpl(String path) {
        this.path = path;
        this.accessor = new javaserial.AccessorImpl(path);
    }
    
    public javaserial.JavaPickleBase GetJavaPickle() 
                        throws xerox.ilu.IluSystemException {
        javaserial.JavaPickle p = null;
        System.out.println("PickleFactoryImpl called");
        FooWhizBangFuzzler x = new FooWhizBangFuzzler("xxxx");
        try {
            p = new javaserial.JavaPickle(x, this.accessor);
        } catch (java.io.IOException e) {
            throw new xerox.ilu.IluSystemException("Couldn't pickle");
        }
        return p;
    } //CreateCalculator
    
} //PickleFactoryImpl



