/* IluUserException.java */
/* Chris Jacobi, July 6, 1997 12:10 pm PDT */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
 
/*
 * IluUserException.java
 * - Applications may catch this exception
 * - This is used by the stubber as base class for client
 *   specified exceptions.  
 */
 
/*
 * $Id: IluUserException.java,v 1.7 1997/07/06 20:36:04 jacobi Exp $
 */

package xerox.ilu;

abstract public 
class IluUserException extends org.omg.CORBA.UserException {

    protected IluUserException() {
	this("IluUserException");
    }
    protected IluUserException(java.lang.String id) {
	super(id);
    }
    
    /** NOT really public; must be accessable by stubs */
    public void readException(IluCall call) 
            throws IluSystemException {
        //Overload this, if the exception has arguments...
    }
    
    /** 
     * NOT really public; must be accessable by stubs
     * Has signature of generic writeException procedures
     * for ease of stub generation  
     */
    public static 
    void writeException(IluUserException ex, int index, IluCall call) 
            throws IluSystemException {
        //Redefine this, if the exception has arguments...
        int sz = 0;
        if (call.needsSizing()) {
            sz = call.beginSizingException(index);
        }
        call.startWriteException(index, sz);
        call.doneWriteException();
    } //writeException
     
} // IluUserException 

