#|
Copyright (c) 1991, 1992, 1993 Xerox Corporation.  All Rights Reserved.  

Unlimited use, reproduction, and distribution of this software is
permitted.  Any copy of this software must include both the above
copyright notice of Xerox Corporation and this paragraph.  Any
distribution of this software must comply with all applicable United
States export control laws.  This software is made available AS IS,
and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

$Id: ilu-types.lisp.orig,v 1.3 1997/09/10 00:13:06 janssen Exp $
|#

(cl:in-package :ilu)

(ilu:define-sequence-type ilu:cstring (:primitive :short-character) 0)

(ilu:define-sequence ilu:cstring
    (ilulisp_get-primitive-type-uid "ilu.CString")
  (:primitive :short-character) 0
  "CString" "ilu" "version 2"
  (ilulisp_get-primitive-type-uid "short character"))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;;  Support for ilu.CORBA-Object
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(ilu:define-class-type corba-object
  ()					; superclasses
  ()					; superclass IDs
  cl:nil				; singleton?
  cl:nil				; authentication
  cl:nil				; brand
  cl:t					; optional?
  cl:nil				; collectible?
  (					; methods
   )
  "2.0alpha11" "CORBA-Object" "ilu" "version 2" "IDL:omg.org/CORBA/Object:1.0"
  cl:nil)

(ilu:define-class corba-object)		; get-class-fn

